/* TrashApplet.c generated by valac 0.56.8, the Vala compiler
 * generated from TrashApplet.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <plugin.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <gio/gio.h>
#include <libpeas/peas.h>

#define TRASH_APPLET_APPLET_MAX_TRASH_ITEMS 100

enum  {
	TRASH_APPLET_PLUGIN_0_PROPERTY,
	TRASH_APPLET_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* trash_applet_plugin_properties[TRASH_APPLET_PLUGIN_NUM_PROPERTIES];
enum  {
	TRASH_APPLET_APPLET_0_PROPERTY,
	TRASH_APPLET_APPLET_UUID_PROPERTY,
	TRASH_APPLET_APPLET_NUM_PROPERTIES
};
static GParamSpec* trash_applet_applet_properties[TRASH_APPLET_APPLET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _trash_applet_trash_handler_unref0(var) ((var == NULL) ? NULL : (var = (trash_applet_trash_handler_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _TrashAppletAppletPrivate {
	GtkEventBox* event_box;
	TrashAppletWidgetsIconButton* icon_button;
	TrashAppletWidgetsMainPopover* popover;
	TrashAppletTrashHandler* trash_handler;
	BudgiePopoverManager* manager;
	gchar* _uuid;
};

struct _Block1Data {
	int _ref_count_;
	TrashAppletApplet* self;
	GdkScreen* screen;
	GtkCssProvider* provider;
	gchar* style_file;
};

static gpointer trash_applet_plugin_parent_class = NULL;
static BudgiePluginIface * trash_applet_plugin_budgie_plugin_parent_iface = NULL;
static GType trash_applet_plugin_type_id = 0;
static gint TrashAppletApplet_private_offset;
static gpointer trash_applet_applet_parent_class = NULL;
static GType trash_applet_applet_type_id = 0;

static BudgieApplet* trash_applet_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                         const gchar* uuid);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda31_ (Block1Data* _data1_);
static gboolean ___lambda31__gsource_func (gpointer self);
static void trash_applet_applet_connect_signals (TrashAppletApplet* self);
static gboolean trash_applet_applet_real_supports_settings (BudgieApplet* base);
static void trash_applet_applet_real_update_popovers (BudgieApplet* base,
                                               BudgiePopoverManager* manager);
static void __lambda32_ (TrashAppletApplet* self);
static void ___lambda32__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void trash_applet_applet_on_drag_data_received (TrashAppletApplet* self,
                                                GtkWidget* widget,
                                                GdkDragContext* context,
                                                gint x,
                                                gint y,
                                                GtkSelectionData* selection_data,
                                                guint item,
                                                guint time);
static void _trash_applet_applet_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                               GdkDragContext* context,
                                                                               gint x,
                                                                               gint y,
                                                                               GtkSelectionData* selection_data,
                                                                               guint info,
                                                                               guint time_,
                                                                               gpointer self);
static void trash_applet_applet_finalize (GObject * obj);
static void _vala_trash_applet_applet_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_trash_applet_applet_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
GType trash_applet_widgets_main_popover_register_type (GTypeModule * module);
GType trash_applet_widgets_icon_button_register_type (GTypeModule * module);
GType trash_applet_widgets_settings_view_register_type (GTypeModule * module);
GType trash_applet_widgets_trash_item_register_type (GTypeModule * module);
GType trash_applet_widgets_trash_store_widget_register_type (GTypeModule * module);
GType trash_applet_trash_handler_register_type (GTypeModule * module);
GType trash_applet_trash_store_register_type (GTypeModule * module);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GtkTargetEntry TRASH_APPLET_APPLET_targets[1] = {{"text/uri-list", (guint) 0, (guint) 0}};

static BudgieApplet*
trash_applet_plugin_real_get_panel_widget (BudgiePlugin* base,
                                           const gchar* uuid)
{
	TrashAppletPlugin * self;
	TrashAppletApplet* _tmp0_;
	BudgieApplet* result;
	self = (TrashAppletPlugin*) base;
	g_return_val_if_fail (uuid != NULL, NULL);
	_tmp0_ = trash_applet_applet_new (uuid);
	g_object_ref_sink (_tmp0_);
	result = (BudgieApplet*) _tmp0_;
	return result;
}

TrashAppletPlugin*
trash_applet_plugin_construct (GType object_type)
{
	TrashAppletPlugin * self = NULL;
	self = (TrashAppletPlugin*) g_object_new (object_type, NULL);
	return self;
}

TrashAppletPlugin*
trash_applet_plugin_new (void)
{
	return trash_applet_plugin_construct (TRASH_APPLET_TYPE_PLUGIN);
}

static void
trash_applet_plugin_class_init (TrashAppletPluginClass * klass,
                                gpointer klass_data)
{
	trash_applet_plugin_parent_class = g_type_class_peek_parent (klass);
}

static void
trash_applet_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                                  gpointer iface_data)
{
	trash_applet_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) trash_applet_plugin_real_get_panel_widget;
}

static void
trash_applet_plugin_instance_init (TrashAppletPlugin * self,
                                   gpointer klass)
{
}

GType
trash_applet_plugin_get_type (void)
{
	return trash_applet_plugin_type_id;
}

GType
trash_applet_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletPlugin), 0, (GInstanceInitFunc) trash_applet_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) trash_applet_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	trash_applet_plugin_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "TrashAppletPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, trash_applet_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return trash_applet_plugin_type_id;
}

static inline gpointer
trash_applet_applet_get_instance_private (TrashAppletApplet* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletApplet_private_offset);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		TrashAppletApplet* self;
		self = _data1_->self;
		_g_free0 (_data1_->style_file);
		_g_object_unref0 (_data1_->provider);
		_g_object_unref0 (_data1_->screen);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
__lambda31_ (Block1Data* _data1_)
{
	TrashAppletApplet* self;
	gboolean result;
	self = _data1_->self;
	gtk_css_provider_load_from_resource (_data1_->provider, _data1_->style_file);
	gtk_style_context_add_provider_for_screen (_data1_->screen, (GtkStyleProvider*) _data1_->provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	result = FALSE;
	return result;
}

static gboolean
___lambda31__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda31_ (self);
	return result;
}

TrashAppletApplet*
trash_applet_applet_construct (GType object_type,
                               const gchar* uuid)
{
	TrashAppletApplet * self = NULL;
	Block1Data* _data1_;
	TrashAppletTrashHandler* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GtkCssProvider* _tmp4_;
	gchar* _tmp5_;
	GtkEventBox* _tmp6_;
	TrashAppletTrashHandler* _tmp7_;
	TrashAppletWidgetsIconButton* _tmp8_;
	GtkEventBox* _tmp9_;
	TrashAppletWidgetsIconButton* _tmp10_;
	GtkEventBox* _tmp11_;
	TrashAppletWidgetsIconButton* _tmp12_;
	TrashAppletTrashHandler* _tmp13_;
	TrashAppletWidgetsMainPopover* _tmp14_;
	TrashAppletWidgetsMainPopover* _tmp15_;
	TrashAppletTrashHandler* _tmp16_;
	GtkEventBox* _tmp17_;
	g_return_val_if_fail (uuid != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	self = (TrashAppletApplet*) g_object_new (object_type, "uuid", uuid, NULL);
	_data1_->self = g_object_ref (self);
	_tmp0_ = trash_applet_trash_handler_new (self);
	_trash_applet_trash_handler_unref0 (self->priv->trash_handler);
	self->priv->trash_handler = _tmp0_;
	_tmp1_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp2_ = gdk_display_get_default_screen (_tmp1_);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_data1_->screen = _tmp3_;
	_tmp4_ = gtk_css_provider_new ();
	_data1_->provider = _tmp4_;
	_tmp5_ = g_strdup ("/org/github/ubuntubudgie/budgie-trash-applet/style/style.css");
	_data1_->style_file = _tmp5_;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda31__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	_tmp6_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->event_box);
	self->priv->event_box = _tmp6_;
	_tmp7_ = self->priv->trash_handler;
	_tmp8_ = trash_applet_widgets_icon_button_new (_tmp7_);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->icon_button);
	self->priv->icon_button = _tmp8_;
	_tmp9_ = self->priv->event_box;
	_tmp10_ = self->priv->icon_button;
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->event_box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->icon_button;
	_tmp13_ = self->priv->trash_handler;
	_tmp14_ = trash_applet_widgets_main_popover_new ((GtkWidget*) _tmp12_, _tmp13_);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp14_;
	_tmp15_ = self->priv->popover;
	trash_applet_widgets_main_popover_set_page (_tmp15_, "main");
	_tmp16_ = self->priv->trash_handler;
	trash_applet_trash_handler_get_current_trash_items (_tmp16_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp17_ = self->priv->event_box;
	gtk_drag_dest_set ((GtkWidget*) _tmp17_, GTK_DEST_DEFAULT_ALL, TRASH_APPLET_APPLET_targets, (gint) G_N_ELEMENTS (TRASH_APPLET_APPLET_targets), GDK_ACTION_COPY);
	trash_applet_applet_connect_signals (self);
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return self;
}

TrashAppletApplet*
trash_applet_applet_new (const gchar* uuid)
{
	return trash_applet_applet_construct (TRASH_APPLET_TYPE_APPLET, uuid);
}

static gboolean
trash_applet_applet_real_supports_settings (BudgieApplet* base)
{
	TrashAppletApplet * self;
	gboolean result;
	self = (TrashAppletApplet*) base;
	result = FALSE;
	return result;
}

static void
trash_applet_applet_real_update_popovers (BudgieApplet* base,
                                          BudgiePopoverManager* manager)
{
	TrashAppletApplet * self;
	TrashAppletWidgetsIconButton* _tmp0_;
	TrashAppletWidgetsMainPopover* _tmp1_;
	self = (TrashAppletApplet*) base;
	_tmp0_ = self->priv->icon_button;
	_tmp1_ = self->priv->popover;
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, (BudgiePopover*) _tmp1_);
	self->priv->manager = manager;
}

void
trash_applet_applet_show_notification (TrashAppletApplet* self,
                                       const gchar* summary,
                                       const gchar* body)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (summary != NULL);
	g_return_if_fail (body != NULL);
	_tmp0_ = g_strdup (_ ("Trash"));
	title = _tmp0_;
	_tmp1_ = g_strconcat ("notify-send -a ", title, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf (" -i user-trash-symbolic '%s' '%s'", summary, body);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	cmd = _tmp6_;
	{
		g_spawn_command_line_async (cmd, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch0_g_spawn_error;
			}
			_g_free0 (cmd);
			_g_free0 (title);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_warning ("TrashApplet.vala:111: Unable to send notification: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (cmd);
		_g_free0 (title);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (cmd);
	_g_free0 (title);
}

static void
__lambda32_ (TrashAppletApplet* self)
{
	TrashAppletWidgetsMainPopover* _tmp0_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = self->priv->popover;
	if (gtk_widget_is_visible ((GtkWidget*) _tmp0_)) {
		TrashAppletWidgetsMainPopover* _tmp1_;
		_tmp1_ = self->priv->popover;
		gtk_widget_hide ((GtkWidget*) _tmp1_);
	} else {
		TrashAppletTrashHandler* _tmp2_;
		_tmp2_ = self->priv->trash_handler;
		if (trash_applet_trash_handler_trash_items_count (_tmp2_) < TRASH_APPLET_APPLET_MAX_TRASH_ITEMS) {
			BudgiePopoverManager* _tmp3_;
			TrashAppletWidgetsIconButton* _tmp4_;
			_tmp3_ = self->priv->manager;
			_tmp4_ = self->priv->icon_button;
			budgie_popover_manager_show_popover (_tmp3_, (GtkWidget*) _tmp4_);
		} else {
			gchar* xdgopen = NULL;
			gchar* _tmp5_;
			_tmp5_ = g_find_program_in_path ("xdg-open");
			xdgopen = _tmp5_;
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				_tmp6_ = xdgopen;
				_tmp7_ = g_strjoin (" ", _tmp6_, "trash://", NULL);
				_tmp8_ = _tmp7_;
				g_spawn_command_line_async (_tmp8_, &_inner_error0_);
				_g_free0 (_tmp8_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_SPAWN_ERROR) {
						goto __catch0_g_spawn_error;
					}
					_g_free0 (xdgopen);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			goto __finally0;
			__catch0_g_spawn_error:
			{
				GError* e = NULL;
				GError* _tmp9_;
				const gchar* _tmp10_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp9_ = e;
				_tmp10_ = _tmp9_->message;
				g_warning ("TrashApplet.vala:139: Unable to spawn trash: %s", _tmp10_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (xdgopen);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_free0 (xdgopen);
		}
	}
}

static void
___lambda32__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda32_ ((TrashAppletApplet*) self);
}

static void
_trash_applet_applet_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                          GdkDragContext* context,
                                                                          gint x,
                                                                          gint y,
                                                                          GtkSelectionData* selection_data,
                                                                          guint info,
                                                                          guint time_,
                                                                          gpointer self)
{
	trash_applet_applet_on_drag_data_received ((TrashAppletApplet*) self, _sender, context, x, y, selection_data, info, time_);
}

static void
trash_applet_applet_connect_signals (TrashAppletApplet* self)
{
	TrashAppletWidgetsIconButton* _tmp0_;
	GtkEventBox* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->icon_button;
	g_signal_connect_object ((GtkButton*) _tmp0_, "clicked", (GCallback) ___lambda32__gtk_button_clicked, self, 0);
	_tmp1_ = self->priv->event_box;
	g_signal_connect_object ((GtkWidget*) _tmp1_, "drag-data-received", (GCallback) _trash_applet_applet_on_drag_data_received_gtk_widget_drag_data_received, self, 0);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
trash_applet_applet_on_drag_data_received (TrashAppletApplet* self,
                                           GtkWidget* widget,
                                           GdkDragContext* context,
                                           gint x,
                                           gint y,
                                           GtkSelectionData* selection_data,
                                           guint item,
                                           guint time)
{
	gchar** data = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint data_length1;
	gint _data_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	if (item != ((guint) 0)) {
		return;
	}
	_tmp1_ = _tmp0_ = gtk_selection_data_get_uris (selection_data);
	data = _tmp1_;
	data_length1 = _vala_array_length (_tmp0_);
	_data_size_ = data_length1;
	_tmp2_ = data;
	_tmp2__length1 = data_length1;
	{
		gchar** dropped_item_collection = NULL;
		gint dropped_item_collection_length1 = 0;
		gint _dropped_item_collection_size_ = 0;
		gint dropped_item_it = 0;
		dropped_item_collection = _tmp2_;
		dropped_item_collection_length1 = _tmp2__length1;
		for (dropped_item_it = 0; dropped_item_it < dropped_item_collection_length1; dropped_item_it = dropped_item_it + 1) {
			gchar* _tmp3_;
			gchar* dropped_item = NULL;
			_tmp3_ = g_strdup (dropped_item_collection[dropped_item_it]);
			dropped_item = _tmp3_;
			{
				const gchar* _tmp4_;
				_tmp4_ = dropped_item;
				if (g_str_has_prefix (_tmp4_, "file://")) {
					gchar* path = NULL;
					const gchar* _tmp5_;
					gchar* _tmp6_;
					const gchar* _tmp7_;
					gchar* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					GFile* file = NULL;
					const gchar* _tmp11_;
					GFile* _tmp12_;
					_tmp5_ = dropped_item;
					_tmp6_ = string_replace (_tmp5_, "file://", "");
					path = _tmp6_;
					_tmp7_ = path;
					_tmp8_ = g_uri_unescape_string (_tmp7_, NULL);
					_g_free0 (path);
					path = _tmp8_;
					_tmp9_ = path;
					_tmp10_ = string_strip (_tmp9_);
					_g_free0 (path);
					path = _tmp10_;
					_tmp11_ = path;
					_tmp12_ = g_file_new_for_path (_tmp11_);
					file = _tmp12_;
					{
						GFile* _tmp13_;
						_tmp13_ = file;
						g_file_trash (_tmp13_, NULL, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp14_;
						GError* _tmp15_;
						const gchar* _tmp16_;
						gchar* _tmp17_;
						gchar* _tmp18_;
						GError* _tmp19_;
						const gchar* _tmp20_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp14_ = path;
						_tmp15_ = e;
						_tmp16_ = _tmp15_->message;
						_tmp17_ = g_strdup_printf ("Unable to trash dragged file '%s': %s", _tmp14_, _tmp16_);
						_tmp18_ = _tmp17_;
						g_warning ("TrashApplet.vala:164: %s", _tmp18_);
						_g_free0 (_tmp18_);
						_tmp19_ = e;
						_tmp20_ = _tmp19_->message;
						trash_applet_applet_show_notification (self, _ ("Error moving to trash:"), _tmp20_);
						_g_error_free0 (e);
					}
					__finally0:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (file);
						_g_free0 (path);
						_g_free0 (dropped_item);
						data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_g_object_unref0 (file);
					_g_free0 (path);
				}
				_g_free0 (dropped_item);
			}
		}
	}
	gtk_drag_finish (context, TRUE, TRUE, (guint32) time);
	data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
}

void
trash_applet_applet_update_trash_icon (TrashAppletApplet* self)
{
	TrashAppletWidgetsIconButton* _tmp0_;
	TrashAppletTrashHandler* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->icon_button;
	_tmp1_ = self->priv->trash_handler;
	trash_applet_widgets_icon_button_set_icon_full (_tmp0_, trash_applet_trash_handler_trash_items_count (_tmp1_) > 0);
}

const gchar*
trash_applet_applet_get_uuid (TrashAppletApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uuid;
	result = _tmp0_;
	return result;
}

void
trash_applet_applet_set_uuid (TrashAppletApplet* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = trash_applet_applet_get_uuid (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_uuid);
		self->priv->_uuid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, trash_applet_applet_properties[TRASH_APPLET_APPLET_UUID_PROPERTY]);
	}
}

static void
trash_applet_applet_class_init (TrashAppletAppletClass * klass,
                                gpointer klass_data)
{
	trash_applet_applet_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TrashAppletApplet_private_offset);
	((BudgieAppletClass *) klass)->supports_settings = (gboolean (*) (BudgieApplet*)) trash_applet_applet_real_supports_settings;
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) trash_applet_applet_real_update_popovers;
	G_OBJECT_CLASS (klass)->get_property = _vala_trash_applet_applet_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_trash_applet_applet_set_property;
	G_OBJECT_CLASS (klass)->finalize = trash_applet_applet_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_APPLET_UUID_PROPERTY, trash_applet_applet_properties[TRASH_APPLET_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
trash_applet_applet_instance_init (TrashAppletApplet * self,
                                   gpointer klass)
{
	self->priv = trash_applet_applet_get_instance_private (self);
	self->priv->event_box = NULL;
	self->priv->icon_button = NULL;
	self->priv->popover = NULL;
	self->priv->trash_handler = NULL;
	self->priv->manager = NULL;
}

static void
trash_applet_applet_finalize (GObject * obj)
{
	TrashAppletApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_TYPE_APPLET, TrashAppletApplet);
	_g_object_unref0 (self->priv->event_box);
	_g_object_unref0 (self->priv->icon_button);
	_g_object_unref0 (self->priv->popover);
	_trash_applet_trash_handler_unref0 (self->priv->trash_handler);
	_g_free0 (self->priv->_uuid);
	G_OBJECT_CLASS (trash_applet_applet_parent_class)->finalize (obj);
}

GType
trash_applet_applet_get_type (void)
{
	return trash_applet_applet_type_id;
}

GType
trash_applet_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletApplet), 0, (GInstanceInitFunc) trash_applet_applet_instance_init, NULL };
	trash_applet_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "TrashAppletApplet", &g_define_type_info, 0);
	TrashAppletApplet_private_offset = sizeof (TrashAppletAppletPrivate);
	return trash_applet_applet_type_id;
}

static void
_vala_trash_applet_applet_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	TrashAppletApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRASH_APPLET_TYPE_APPLET, TrashAppletApplet);
	switch (property_id) {
		case TRASH_APPLET_APPLET_UUID_PROPERTY:
		g_value_set_string (value, trash_applet_applet_get_uuid (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_trash_applet_applet_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	TrashAppletApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRASH_APPLET_TYPE_APPLET, TrashAppletApplet);
	switch (property_id) {
		case TRASH_APPLET_APPLET_UUID_PROPERTY:
		trash_applet_applet_set_uuid (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
	g_return_if_fail (module != NULL);
	trash_applet_widgets_main_popover_register_type (module);
	trash_applet_widgets_icon_button_register_type (module);
	trash_applet_widgets_settings_view_register_type (module);
	trash_applet_widgets_trash_item_register_type (module);
	trash_applet_widgets_trash_store_widget_register_type (module);
	trash_applet_plugin_register_type (module);
	trash_applet_applet_register_type (module);
	trash_applet_trash_handler_register_type (module);
	trash_applet_trash_store_register_type (module);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
	objmodule = _tmp0_;
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TRASH_APPLET_TYPE_PLUGIN);
	_g_object_unref0 (objmodule);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

