/* TrashStore.c generated by valac 0.56.8, the Vala compiler
 * generated from TrashStore.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _trash_applet_trash_store_unref0(var) ((var == NULL) ? NULL : (var = (trash_applet_trash_store_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
typedef struct _TrashAppletParamSpecTrashStore TrashAppletParamSpecTrashStore;
enum  {
	TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL,
	TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL,
	TRASH_APPLET_TRASH_STORE_NUM_SIGNALS
};
static guint trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_NUM_SIGNALS] = {0};

struct _TrashAppletTrashStorePrivate {
	TrashAppletApplet* applet;
	GFile* trash_dir;
	GFile* info_dir;
	gchar* drive_name;
	gchar* drive_path;
	GIcon* drive_icon;
	GFileMonitor* trash_monitor;
	gint _trash_count;
};

struct _Block4Data {
	int _ref_count_;
	TrashAppletTrashStore* self;
	GFile* file;
	GFile* info_file;
	gchar* file_name;
};

struct _TrashAppletParamSpecTrashStore {
	GParamSpec parent_instance;
};

static gint TrashAppletTrashStore_private_offset;
static gpointer trash_applet_trash_store_parent_class = NULL;
static GType trash_applet_trash_store_type_id = 0;

static void trash_applet_trash_store_handle_trash_changed (TrashAppletTrashStore* self,
                                                    GFile* file,
                                                    GFile* other_file,
                                                    GFileMonitorEvent event);
static void _trash_applet_trash_store_handle_trash_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                            GFile* file,
                                                                            GFile* other_file,
                                                                            GFileMonitorEvent event_type,
                                                                            gpointer self);
static gchar* trash_applet_trash_store_get_path_from_trashinfo (TrashAppletTrashStore* self,
                                                         const gchar* file_name);
static GDateTime* trash_applet_trash_store_get_deletion_date (TrashAppletTrashStore* self,
                                                       const gchar* file_name);
static void trash_applet_trash_store_set_trash_count (TrashAppletTrashStore* self,
                                               gint value);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gint ___lambda5_ (Block4Data* _data4_);
static void trash_applet_trash_store_delete_directory (TrashAppletTrashStore* self,
                                                GFile* dir,
                                                GError** error);
static gpointer ____lambda5__gthread_func (gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN (GClosure * closure,
                                                                       GValue * return_value,
                                                                       guint n_param_values,
                                                                       const GValue * param_values,
                                                                       gpointer invocation_hint,
                                                                       gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void trash_applet_trash_store_finalize (TrashAppletTrashStore * obj);

static inline gpointer
trash_applet_trash_store_get_instance_private (TrashAppletTrashStore* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletTrashStore_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_trash_applet_trash_store_handle_trash_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                       GFile* file,
                                                                       GFile* other_file,
                                                                       GFileMonitorEvent event_type,
                                                                       gpointer self)
{
	trash_applet_trash_store_handle_trash_changed ((TrashAppletTrashStore*) self, file, other_file, event_type);
}

TrashAppletTrashStore*
trash_applet_trash_store_construct (GType object_type,
                                    TrashAppletApplet* applet,
                                    GFile* trash_dir,
                                    GFile* info_dir,
                                    const gchar* drive_name,
                                    const gchar* drive_path,
                                    GIcon* drive_icon)
{
	TrashAppletTrashStore* self = NULL;
	TrashAppletApplet* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GIcon* _tmp5_;
	GFileMonitor* _tmp11_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (applet != NULL, NULL);
	g_return_val_if_fail (trash_dir != NULL, NULL);
	g_return_val_if_fail (info_dir != NULL, NULL);
	g_return_val_if_fail (drive_name != NULL, NULL);
	g_return_val_if_fail (drive_icon != NULL, NULL);
	self = (TrashAppletTrashStore*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (applet);
	_g_object_unref0 (self->priv->applet);
	self->priv->applet = _tmp0_;
	_tmp1_ = _g_object_ref0 (trash_dir);
	_g_object_unref0 (self->priv->trash_dir);
	self->priv->trash_dir = _tmp1_;
	_tmp2_ = _g_object_ref0 (info_dir);
	_g_object_unref0 (self->priv->info_dir);
	self->priv->info_dir = _tmp2_;
	_tmp3_ = g_strdup (drive_name);
	_g_free0 (self->priv->drive_name);
	self->priv->drive_name = _tmp3_;
	_tmp4_ = g_strdup (drive_path);
	_g_free0 (self->priv->drive_path);
	self->priv->drive_path = _tmp4_;
	_tmp5_ = _g_object_ref0 (drive_icon);
	_g_object_unref0 (self->priv->drive_icon);
	self->priv->drive_icon = _tmp5_;
	{
		GFileMonitor* _tmp6_ = NULL;
		GFileMonitor* _tmp7_;
		GFileMonitor* _tmp8_;
		_tmp7_ = g_file_monitor_directory (trash_dir, G_FILE_MONITOR_WATCH_MOVES, NULL, &_inner_error0_);
		_tmp6_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp8_ = _tmp6_;
		_tmp6_ = NULL;
		_g_object_unref0 (self->priv->trash_monitor);
		self->priv->trash_monitor = _tmp8_;
		_g_object_unref0 (_tmp6_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("TrashStore.vala:57: Unable to create a TrashStore: %s", _tmp10_);
		_g_error_free0 (e);
		return self;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp11_ = self->priv->trash_monitor;
	g_signal_connect (_tmp11_, "changed", (GCallback) _trash_applet_trash_store_handle_trash_changed_g_file_monitor_changed, self);
	return self;
}

TrashAppletTrashStore*
trash_applet_trash_store_new (TrashAppletApplet* applet,
                              GFile* trash_dir,
                              GFile* info_dir,
                              const gchar* drive_name,
                              const gchar* drive_path,
                              GIcon* drive_icon)
{
	return trash_applet_trash_store_construct (TRASH_APPLET_TYPE_TRASH_STORE, applet, trash_dir, info_dir, drive_name, drive_path, drive_icon);
}

/**
         * Gets all of the current items in this store's trash bin.
         *
         * A `trash_added` signal is emitted for each found trash item so
         * the UI can add each one accordingly.
         */
void
trash_applet_trash_store_get_current_trash_items (TrashAppletTrashStore* self)
{
	TrashAppletApplet* _tmp30_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gchar* attributes = NULL;
		gchar* _tmp0_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp1_;
		const gchar* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileInfo* info = NULL;
		_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_ICON "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
		attributes = _tmp0_;
		_tmp1_ = self->priv->trash_dir;
		_tmp2_ = attributes;
		_tmp3_ = g_file_enumerate_children (_tmp1_, _tmp2_, 0, NULL, &_inner_error0_);
		enumerator = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (attributes);
			goto __catch0_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp4_ = NULL;
			GFileEnumerator* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			gchar* path = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			gboolean is_directory = FALSE;
			GFileInfo* _tmp15_;
			GDateTime* deletion_time = NULL;
			GFileInfo* _tmp16_;
			const gchar* _tmp17_;
			GDateTime* _tmp18_;
			gint _tmp19_;
			GFileInfo* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			GFileInfo* _tmp25_;
			GIcon* _tmp26_;
			GDateTime* _tmp27_;
			_tmp5_ = enumerator;
			_tmp6_ = g_file_enumerator_next_file (_tmp5_, NULL, &_inner_error0_);
			_tmp4_ = _tmp6_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				_g_free0 (attributes);
				goto __catch0_g_error;
			}
			_tmp7_ = _tmp4_;
			_tmp4_ = NULL;
			_g_object_unref0 (info);
			info = _tmp7_;
			_tmp8_ = info;
			if (!(_tmp8_ != NULL)) {
				_g_object_unref0 (_tmp4_);
				break;
			}
			_tmp9_ = info;
			_tmp10_ = g_file_info_get_name (_tmp9_);
			_tmp11_ = trash_applet_trash_store_get_path_from_trashinfo (self, _tmp10_);
			path = _tmp11_;
			_tmp12_ = path;
			if (_tmp12_ == NULL) {
				GFileInfo* _tmp13_;
				const gchar* _tmp14_;
				_tmp13_ = info;
				_tmp14_ = g_file_info_get_name (_tmp13_);
				g_warning ("TrashStore.vala:82: Unable to get the path for %s", _tmp14_);
				_g_free0 (path);
				_g_object_unref0 (_tmp4_);
				continue;
			}
			is_directory = FALSE;
			_tmp15_ = info;
			if (g_file_info_get_file_type (_tmp15_) == G_FILE_TYPE_DIRECTORY) {
				is_directory = TRUE;
			}
			_tmp16_ = info;
			_tmp17_ = g_file_info_get_name (_tmp16_);
			_tmp18_ = trash_applet_trash_store_get_deletion_date (self, _tmp17_);
			deletion_time = _tmp18_;
			_tmp19_ = self->priv->_trash_count;
			trash_applet_trash_store_set_trash_count (self, _tmp19_ + 1);
			_tmp20_ = info;
			_tmp21_ = g_file_info_get_name (_tmp20_);
			_tmp22_ = path;
			_tmp23_ = g_uri_unescape_string (_tmp22_, NULL);
			_tmp24_ = _tmp23_;
			_tmp25_ = info;
			_tmp26_ = g_file_info_get_icon (_tmp25_);
			_tmp27_ = deletion_time;
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL], 0, _tmp21_, _tmp24_, _tmp26_, _tmp27_, is_directory);
			_g_free0 (_tmp24_);
			_g_date_time_unref0 (deletion_time);
			_g_free0 (path);
			_g_object_unref0 (_tmp4_);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
		_g_free0 (attributes);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp28_ = e;
		_tmp29_ = _tmp28_->message;
		g_warning ("TrashStore.vala:97: Unable to create trash item: %s", _tmp29_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp30_ = self->priv->applet;
	trash_applet_applet_update_trash_icon (_tmp30_);
}

gchar*
trash_applet_trash_store_get_drive_name (TrashAppletTrashStore* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->drive_name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}

GIcon*
trash_applet_trash_store_get_drive_icon (TrashAppletTrashStore* self)
{
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	GIcon* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->drive_icon;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
         * Delete a file permanently from the trash.
         *
         * If the file is a directory, it will be recursively deleted.
         * This function spawns a new thread to do the deleting to
         * avoid locking the system up when removing large files.
         *
         * @param file_name The name of the file to delete
         */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		TrashAppletTrashStore* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->info_file);
		_g_object_unref0 (_data4_->file);
		_g_free0 (_data4_->file_name);
		_trash_applet_trash_store_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static gint
___lambda5_ (Block4Data* _data4_)
{
	TrashAppletTrashStore* self;
	GFileType type = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	self = _data4_->self;
	type = g_file_query_file_type (_data4_->file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
	if (type == G_FILE_TYPE_DIRECTORY) {
		{
			trash_applet_trash_store_delete_directory (self, _data4_->file, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp0_;
			const gchar* _tmp1_;
			TrashAppletApplet* _tmp2_;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp0_ = e;
			_tmp1_ = _tmp0_->message;
			g_warning ("TrashStore.vala:133: Unable to delete directory '%s' in trash: %s", _data4_->file_name, _tmp1_);
			_tmp2_ = self->priv->applet;
			_tmp3_ = e;
			_tmp4_ = _tmp3_->message;
			_tmp5_ = g_strdup_printf (_ ("Unable to permanently delete '%s': %s"), _data4_->file_name, _tmp4_);
			_tmp6_ = _tmp5_;
			trash_applet_applet_show_notification (_tmp2_, _ ("Empty Trash"), _tmp6_);
			_g_free0 (_tmp6_);
			result = -1;
			_g_error_free0 (e);
			return result;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp7_ = -1;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp7_;
		}
	}
	{
		g_file_delete (_data4_->file, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		g_file_delete (_data4_->info_file, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		TrashAppletApplet* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_warning ("TrashStore.vala:144: Unable to delete directory '%s' in trash: %s", _data4_->file_name, _tmp9_);
		_tmp10_ = self->priv->applet;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		_tmp13_ = g_strdup_printf (_ ("Unable to permanently delete '%s': %s"), _data4_->file_name, _tmp12_);
		_tmp14_ = _tmp13_;
		trash_applet_applet_show_notification (_tmp10_, _ ("Empty Trash"), _tmp14_);
		_g_free0 (_tmp14_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp15_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp15_;
	}
	result = 0;
	return result;
}

static gpointer
____lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda5_ (self));
	block4_data_unref (self);
	return result;
}

void
trash_applet_trash_store_delete_file (TrashAppletTrashStore* self,
                                      const gchar* file_name)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GFile* _tmp19_;
	GFile* _tmp20_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_name != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = trash_applet_trash_store_ref (self);
	_tmp0_ = g_strdup (file_name);
	_g_free0 (_data4_->file_name);
	_data4_->file_name = _tmp0_;
	_tmp1_ = self->priv->trash_dir;
	_tmp2_ = g_file_get_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "/", NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp5_, _data4_->file_name, NULL);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_file_new_for_path (_tmp7_);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_data4_->file = _tmp9_;
	_tmp10_ = self->priv->info_dir;
	_tmp11_ = g_file_get_path (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat (_tmp12_, "/", NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_strconcat (_tmp14_, _data4_->file_name, NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strconcat (_tmp16_, ".trashinfo", NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_file_new_for_path (_tmp18_);
	_tmp20_ = _tmp19_;
	_g_free0 (_tmp18_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	_data4_->info_file = _tmp20_;
	{
		GThread* _tmp21_;
		GThread* _tmp22_;
		_tmp21_ = g_thread_try_new ("trash-delete-thread", ____lambda5__gthread_func, block4_data_ref (_data4_), &_inner_error0_);
		_tmp22_ = _tmp21_;
		_g_thread_unref0 (_tmp22_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
		TrashAppletApplet* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp23_ = e;
		_tmp24_ = _tmp23_->message;
		g_warning ("TrashStore.vala:151: Unable to delete '%s': %s", _data4_->file_name, _tmp24_);
		_tmp25_ = self->priv->applet;
		_tmp26_ = e;
		_tmp27_ = _tmp26_->message;
		_tmp28_ = g_strdup_printf (_ ("Unable to permanently delete '%s': %s"), _data4_->file_name, _tmp27_);
		_tmp29_ = _tmp28_;
		trash_applet_applet_show_notification (_tmp25_, _ ("Empty Trash"), _tmp29_);
		_g_free0 (_tmp29_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		block4_data_unref (_data4_);
		_data4_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

/**
         * Recursively delete a directory.
         */
static void
trash_applet_trash_store_delete_directory (TrashAppletTrashStore* self,
                                           GFile* dir,
                                           GError** error)
{
	gchar* attributes = NULL;
	gchar* _tmp0_;
	GFileEnumerator* enumerator = NULL;
	const gchar* _tmp1_;
	GFileEnumerator* _tmp2_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
	attributes = _tmp0_;
	_tmp1_ = attributes;
	_tmp2_ = g_file_enumerate_children (dir, _tmp1_, 0, NULL, &_inner_error0_);
	enumerator = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (attributes);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp3_ = NULL;
		GFileEnumerator* _tmp4_;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFile* child = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFileInfo* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
		GFileInfo* _tmp18_;
		_tmp4_ = enumerator;
		_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			_g_free0 (attributes);
			return;
		}
		_tmp6_ = _tmp3_;
		_tmp3_ = NULL;
		_g_object_unref0 (info);
		info = _tmp6_;
		_tmp7_ = info;
		if (!(_tmp7_ != NULL)) {
			_g_object_unref0 (_tmp3_);
			break;
		}
		_tmp8_ = g_file_get_path (dir);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strconcat (_tmp9_, "/", NULL);
		_tmp11_ = _tmp10_;
		_tmp12_ = info;
		_tmp13_ = g_file_info_get_name (_tmp12_);
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_file_new_for_path (_tmp15_);
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp15_);
		_g_free0 (_tmp11_);
		_g_free0 (_tmp9_);
		child = _tmp17_;
		_tmp18_ = info;
		if (g_file_info_get_file_type (_tmp18_) == G_FILE_TYPE_DIRECTORY) {
			GFile* _tmp19_;
			GFile* _tmp20_;
			_tmp19_ = child;
			trash_applet_trash_store_delete_directory (self, _tmp19_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (child);
				_g_object_unref0 (_tmp3_);
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				_g_free0 (attributes);
				return;
			}
			_tmp20_ = child;
			g_file_delete (_tmp20_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (child);
				_g_object_unref0 (_tmp3_);
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				_g_free0 (attributes);
				return;
			}
		} else {
			GFile* _tmp21_;
			_tmp21_ = child;
			g_file_delete (_tmp21_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (child);
				_g_object_unref0 (_tmp3_);
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				_g_free0 (attributes);
				return;
			}
		}
		_g_object_unref0 (child);
		_g_object_unref0 (_tmp3_);
	}
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
	_g_free0 (attributes);
}

void
trash_applet_trash_store_restore_file (TrashAppletTrashStore* self,
                                       const gchar* file_name,
                                       const gchar* restore_path)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* info_file = NULL;
	GFile* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	gchar* rpath = NULL;
	gchar* _tmp20_;
	GFile* destination = NULL;
	const gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_name != NULL);
	g_return_if_fail (restore_path != NULL);
	_tmp0_ = self->priv->trash_dir;
	_tmp1_ = g_file_get_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, file_name, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_file_new_for_path (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	file = _tmp8_;
	_tmp9_ = self->priv->info_dir;
	_tmp10_ = g_file_get_path (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "/", NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, file_name, NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strconcat (_tmp15_, ".trashinfo", NULL);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_file_new_for_path (_tmp17_);
	_tmp19_ = _tmp18_;
	_g_free0 (_tmp17_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	info_file = _tmp19_;
	_tmp20_ = g_uri_unescape_string (restore_path, NULL);
	rpath = _tmp20_;
	_tmp21_ = self->priv->drive_path;
	if (_tmp21_ != NULL) {
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GFile* _tmp28_;
		_tmp22_ = self->priv->drive_path;
		_tmp23_ = g_strconcat (_tmp22_, "/", NULL);
		_tmp24_ = _tmp23_;
		_tmp25_ = rpath;
		_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
		_tmp27_ = _tmp26_;
		_tmp28_ = g_file_new_for_path (_tmp27_);
		_g_object_unref0 (destination);
		destination = _tmp28_;
		_g_free0 (_tmp27_);
		_g_free0 (_tmp24_);
	} else {
		const gchar* _tmp29_;
		GFile* _tmp30_;
		_tmp29_ = rpath;
		_tmp30_ = g_file_new_for_path (_tmp29_);
		_g_object_unref0 (destination);
		destination = _tmp30_;
	}
	{
		GFile* _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
		_tmp31_ = file;
		_tmp32_ = destination;
		g_file_move (_tmp31_, _tmp32_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp33_ = info_file;
		g_file_delete (_tmp33_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp34_;
		GError* _tmp35_;
		const gchar* _tmp36_;
		TrashAppletApplet* _tmp37_;
		const gchar* _tmp38_;
		GError* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp34_ = rpath;
		_tmp35_ = e;
		_tmp36_ = _tmp35_->message;
		g_warning ("TrashStore.vala:192: Unable to restore '%s' to '%s': %s", file_name, _tmp34_, _tmp36_);
		_tmp37_ = self->priv->applet;
		_tmp38_ = rpath;
		_tmp39_ = e;
		_tmp40_ = _tmp39_->message;
		_tmp41_ = g_strdup_printf (_ ("Unable to restore '%s' to %s: %s"), file_name, _tmp38_, _tmp40_);
		_tmp42_ = _tmp41_;
		trash_applet_applet_show_notification (_tmp37_, _ ("Restore"), _tmp42_);
		_g_free0 (_tmp42_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (destination);
		_g_free0 (rpath);
		_g_object_unref0 (info_file);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (destination);
	_g_free0 (rpath);
	_g_object_unref0 (info_file);
	_g_object_unref0 (file);
}

static void
trash_applet_trash_store_handle_trash_changed (TrashAppletTrashStore* self,
                                               GFile* file,
                                               GFile* other_file,
                                               GFileMonitorEvent event)
{
	TrashAppletApplet* _tmp27_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	switch (event) {
		case G_FILE_MONITOR_EVENT_MOVED_IN:
		{
			gchar* file_name = NULL;
			gchar* _tmp0_;
			gchar* file_path = NULL;
			const gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* attributes = NULL;
			gchar* _tmp3_;
			GIcon* file_icon = NULL;
			gboolean is_directory = FALSE;
			GDateTime* deletion_time = NULL;
			GDateTime* _tmp13_;
			gint _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			GIcon* _tmp17_;
			GDateTime* _tmp18_;
			_tmp0_ = g_file_get_basename (file);
			file_name = _tmp0_;
			_tmp1_ = file_name;
			_tmp2_ = trash_applet_trash_store_get_path_from_trashinfo (self, _tmp1_);
			file_path = _tmp2_;
			_tmp3_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_ICON "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
			attributes = _tmp3_;
			file_icon = NULL;
			is_directory = FALSE;
			{
				GFileInfo* file_info = NULL;
				const gchar* _tmp4_;
				GFileInfo* _tmp5_;
				GFileInfo* _tmp6_;
				GIcon* _tmp7_;
				GIcon* _tmp8_;
				GFileInfo* _tmp9_;
				_tmp4_ = attributes;
				_tmp5_ = g_file_query_info (file, _tmp4_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
				file_info = _tmp5_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp6_ = file_info;
				_tmp7_ = g_file_info_get_icon (_tmp6_);
				_tmp8_ = _g_object_ref0 (_tmp7_);
				_g_object_unref0 (file_icon);
				file_icon = _tmp8_;
				_tmp9_ = file_info;
				if (g_file_info_get_file_type (_tmp9_) == G_FILE_TYPE_DIRECTORY) {
					is_directory = TRUE;
				}
				_g_object_unref0 (file_info);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp10_;
				GError* _tmp11_;
				const gchar* _tmp12_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp10_ = file_name;
				_tmp11_ = e;
				_tmp12_ = _tmp11_->message;
				g_warning ("TrashStore.vala:215: Unable to get icon from file info for file '%s': " \
"%s", _tmp10_, _tmp12_);
				_g_error_free0 (e);
				_g_object_unref0 (file_icon);
				_g_free0 (attributes);
				_g_free0 (file_path);
				_g_free0 (file_name);
				break;
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (file_icon);
				_g_free0 (attributes);
				_g_free0 (file_path);
				_g_free0 (file_name);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_tmp13_ = g_date_time_new_now_local ();
			deletion_time = _tmp13_;
			_tmp14_ = self->priv->_trash_count;
			trash_applet_trash_store_set_trash_count (self, _tmp14_ + 1);
			_tmp15_ = file_name;
			_tmp16_ = file_path;
			_tmp17_ = file_icon;
			_tmp18_ = deletion_time;
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL], 0, _tmp15_, _tmp16_, _tmp17_, _tmp18_, is_directory);
			_g_date_time_unref0 (deletion_time);
			_g_object_unref0 (file_icon);
			_g_free0 (attributes);
			_g_free0 (file_path);
			_g_free0 (file_name);
			break;
		}
		case G_FILE_MONITOR_EVENT_MOVED_OUT:
		{
			gchar* file_name = NULL;
			gchar* _tmp19_;
			gint _tmp20_;
			const gchar* _tmp21_;
			gint _tmp22_;
			_tmp19_ = g_file_get_basename (file);
			file_name = _tmp19_;
			_tmp20_ = self->priv->_trash_count;
			trash_applet_trash_store_set_trash_count (self, _tmp20_ - 1);
			_tmp21_ = file_name;
			_tmp22_ = self->priv->_trash_count;
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL], 0, _tmp21_, _tmp22_ == 0);
			_g_free0 (file_name);
			break;
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			gchar* file_name = NULL;
			gchar* _tmp23_;
			gint _tmp24_;
			const gchar* _tmp25_;
			gint _tmp26_;
			_tmp23_ = g_file_get_basename (file);
			file_name = _tmp23_;
			_tmp24_ = self->priv->_trash_count;
			trash_applet_trash_store_set_trash_count (self, _tmp24_ - 1);
			_tmp25_ = file_name;
			_tmp26_ = self->priv->_trash_count;
			g_signal_emit (self, trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL], 0, _tmp25_, _tmp26_ == 0);
			_g_free0 (file_name);
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp27_ = self->priv->applet;
	trash_applet_applet_update_trash_icon (_tmp27_);
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static gchar*
trash_applet_trash_store_get_path_from_trashinfo (TrashAppletTrashStore* self,
                                                  const gchar* file_name)
{
	GFile* info_file = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* line = NULL;
	gchar* path = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file_name != NULL, NULL);
	_tmp0_ = self->priv->info_dir;
	_tmp1_ = g_file_get_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, file_name, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, ".trashinfo", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_file_new_for_path (_tmp8_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	info_file = _tmp10_;
	line = NULL;
	path = NULL;
	{
		GFileInputStream* _tmp11_ = NULL;
		GFile* _tmp12_;
		GFileInputStream* _tmp13_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp14_;
		_tmp12_ = info_file;
		_tmp13_ = g_file_read (_tmp12_, NULL, &_inner_error0_);
		_tmp11_ = _tmp13_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp14_ = g_data_input_stream_new ((GInputStream*) _tmp11_);
		dis = _tmp14_;
		while (TRUE) {
			gchar* _tmp15_ = NULL;
			GDataInputStream* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp16_ = dis;
			_tmp17_ = g_data_input_stream_read_line (_tmp16_, NULL, NULL, &_inner_error0_);
			_tmp15_ = _tmp17_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (dis);
				_g_object_unref0 (_tmp11_);
				goto __catch0_g_error;
			}
			_tmp18_ = _tmp15_;
			_tmp15_ = NULL;
			_g_free0 (line);
			line = _tmp18_;
			_tmp19_ = line;
			if (!(_tmp19_ != NULL)) {
				_g_free0 (_tmp15_);
				break;
			}
			_tmp20_ = line;
			if (!g_str_has_prefix (_tmp20_, "Path=")) {
				_g_free0 (_tmp15_);
				continue;
			}
			_tmp21_ = line;
			_tmp22_ = string_substring (_tmp21_, (glong) 5, (glong) -1);
			_g_free0 (path);
			path = _tmp22_;
			_g_free0 (_tmp15_);
			break;
		}
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp11_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp23_ = e;
		_tmp24_ = _tmp23_->message;
		g_warning ("TrashStore.vala:256: Error reading data from .trashinfo: %s", _tmp24_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (path);
		_g_free0 (line);
		_g_object_unref0 (info_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = path;
	_g_free0 (line);
	_g_object_unref0 (info_file);
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static GDateTime*
trash_applet_trash_store_get_deletion_date (TrashAppletTrashStore* self,
                                            const gchar* file_name)
{
	GFile* info_file = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* line = NULL;
	gchar* date_string = NULL;
	const gchar* _tmp25_;
	GTimeZone* _tmp26_;
	GTimeZone* _tmp27_;
	GDateTime* _tmp28_;
	GDateTime* _tmp29_;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file_name != NULL, NULL);
	_tmp0_ = self->priv->info_dir;
	_tmp1_ = g_file_get_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, file_name, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, ".trashinfo", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_file_new_for_path (_tmp8_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	info_file = _tmp10_;
	line = NULL;
	date_string = NULL;
	{
		GFileInputStream* _tmp11_ = NULL;
		GFile* _tmp12_;
		GFileInputStream* _tmp13_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp14_;
		_tmp12_ = info_file;
		_tmp13_ = g_file_read (_tmp12_, NULL, &_inner_error0_);
		_tmp11_ = _tmp13_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp14_ = g_data_input_stream_new ((GInputStream*) _tmp11_);
		dis = _tmp14_;
		while (TRUE) {
			gchar* _tmp15_ = NULL;
			GDataInputStream* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp16_ = dis;
			_tmp17_ = g_data_input_stream_read_line (_tmp16_, NULL, NULL, &_inner_error0_);
			_tmp15_ = _tmp17_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (dis);
				_g_object_unref0 (_tmp11_);
				goto __catch0_g_error;
			}
			_tmp18_ = _tmp15_;
			_tmp15_ = NULL;
			_g_free0 (line);
			line = _tmp18_;
			_tmp19_ = line;
			if (!(_tmp19_ != NULL)) {
				_g_free0 (_tmp15_);
				break;
			}
			_tmp20_ = line;
			if (!g_str_has_prefix (_tmp20_, "DeletionDate=")) {
				_g_free0 (_tmp15_);
				continue;
			}
			_tmp21_ = line;
			_tmp22_ = string_replace (_tmp21_, "DeletionDate=", "");
			_g_free0 (date_string);
			date_string = _tmp22_;
			_g_free0 (_tmp15_);
			break;
		}
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp11_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp23_ = e;
		_tmp24_ = _tmp23_->message;
		g_warning ("TrashStore.vala:278: Error reading data from .trashinfo: %s", _tmp24_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (date_string);
		_g_free0 (line);
		_g_object_unref0 (info_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp25_ = date_string;
	_tmp26_ = g_time_zone_new_local ();
	_tmp27_ = _tmp26_;
	_tmp28_ = g_date_time_new_from_iso8601 (_tmp25_, _tmp27_);
	_tmp29_ = _tmp28_;
	_g_time_zone_unref0 (_tmp27_);
	result = _tmp29_;
	_g_free0 (date_string);
	_g_free0 (line);
	_g_object_unref0 (info_file);
	return result;
}

gint
trash_applet_trash_store_get_trash_count (TrashAppletTrashStore* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_trash_count;
	return result;
}

static void
trash_applet_trash_store_set_trash_count (TrashAppletTrashStore* self,
                                          gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_trash_count = value;
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN (GClosure * closure,
                                                                  GValue * return_value,
                                                                  guint n_param_values,
                                                                  const GValue * param_values,
                                                                  gpointer invocation_hint,
                                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN) (gpointer data1, const char* arg_1, const char* arg_2, gpointer arg_3, gpointer arg_4, gboolean arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 6);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_object (param_values + 3), g_value_get_boxed (param_values + 4), g_value_get_boolean (param_values + 5), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_BOOLEAN) (gpointer data1, const char* arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}

static void
trash_applet_value_trash_store_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
trash_applet_value_trash_store_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		trash_applet_trash_store_unref (value->data[0].v_pointer);
	}
}

static void
trash_applet_value_trash_store_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = trash_applet_trash_store_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
trash_applet_value_trash_store_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
trash_applet_value_trash_store_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		TrashAppletTrashStore * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = trash_applet_trash_store_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
trash_applet_value_trash_store_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	TrashAppletTrashStore ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = trash_applet_trash_store_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
trash_applet_param_spec_trash_store (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	TrashAppletParamSpecTrashStore* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TRASH_APPLET_TYPE_TRASH_STORE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
trash_applet_value_get_trash_store (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TRASH_APPLET_TYPE_TRASH_STORE), NULL);
	return value->data[0].v_pointer;
}

void
trash_applet_value_set_trash_store (GValue* value,
                                    gpointer v_object)
{
	TrashAppletTrashStore * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TRASH_APPLET_TYPE_TRASH_STORE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TRASH_APPLET_TYPE_TRASH_STORE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		trash_applet_trash_store_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		trash_applet_trash_store_unref (old);
	}
}

void
trash_applet_value_take_trash_store (GValue* value,
                                     gpointer v_object)
{
	TrashAppletTrashStore * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TRASH_APPLET_TYPE_TRASH_STORE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TRASH_APPLET_TYPE_TRASH_STORE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		trash_applet_trash_store_unref (old);
	}
}

static void
trash_applet_trash_store_class_init (TrashAppletTrashStoreClass * klass,
                                     gpointer klass_data)
{
	trash_applet_trash_store_parent_class = g_type_class_peek_parent (klass);
	((TrashAppletTrashStoreClass *) klass)->finalize = trash_applet_trash_store_finalize;
	g_type_class_adjust_private_offset (klass, &TrashAppletTrashStore_private_offset);
	trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_ADDED_SIGNAL] = g_signal_new ("trash-added", TRASH_APPLET_TYPE_TRASH_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT_BOXED_BOOLEAN, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type (), G_TYPE_DATE_TIME, G_TYPE_BOOLEAN);
	trash_applet_trash_store_signals[TRASH_APPLET_TRASH_STORE_TRASH_REMOVED_SIGNAL] = g_signal_new ("trash-removed", TRASH_APPLET_TYPE_TRASH_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
}

static void
trash_applet_trash_store_instance_init (TrashAppletTrashStore * self,
                                        gpointer klass)
{
	self->priv = trash_applet_trash_store_get_instance_private (self);
	self->priv->_trash_count = 0;
	self->ref_count = 1;
}

static void
trash_applet_trash_store_finalize (TrashAppletTrashStore * obj)
{
	TrashAppletTrashStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_TYPE_TRASH_STORE, TrashAppletTrashStore);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->applet);
	_g_object_unref0 (self->priv->trash_dir);
	_g_object_unref0 (self->priv->info_dir);
	_g_free0 (self->priv->drive_name);
	_g_free0 (self->priv->drive_path);
	_g_object_unref0 (self->priv->drive_icon);
	_g_object_unref0 (self->priv->trash_monitor);
}

/**
     * TrashStore represents a trash bin on the user's system.
     *
     * Removable drives may have their own trash locations that should be tracked,
     * along with the user's main trash bin.
     */
GType
trash_applet_trash_store_get_type (void)
{
	return trash_applet_trash_store_type_id;
}

GType
trash_applet_trash_store_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { trash_applet_value_trash_store_init, trash_applet_value_trash_store_free_value, trash_applet_value_trash_store_copy_value, trash_applet_value_trash_store_peek_pointer, "p", trash_applet_value_trash_store_collect_value, "p", trash_applet_value_trash_store_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletTrashStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_trash_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletTrashStore), 0, (GInstanceInitFunc) trash_applet_trash_store_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	trash_applet_trash_store_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TrashAppletTrashStore", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TrashAppletTrashStore_private_offset = sizeof (TrashAppletTrashStorePrivate);
	return trash_applet_trash_store_type_id;
}

gpointer
trash_applet_trash_store_ref (gpointer instance)
{
	TrashAppletTrashStore * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
trash_applet_trash_store_unref (gpointer instance)
{
	TrashAppletTrashStore * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TRASH_APPLET_TRASH_STORE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

