/* IconButton.c generated by valac 0.56.8, the Vala compiler
 * generated from IconButton.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	TRASH_APPLET_WIDGETS_ICON_BUTTON_0_PROPERTY,
	TRASH_APPLET_WIDGETS_ICON_BUTTON_NUM_PROPERTIES
};
static GParamSpec* trash_applet_widgets_icon_button_properties[TRASH_APPLET_WIDGETS_ICON_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _trash_applet_trash_handler_unref0(var) ((var == NULL) ? NULL : (var = (trash_applet_trash_handler_unref (var), NULL)))

struct _TrashAppletWidgetsIconButtonPrivate {
	GtkImage* icon_empty;
	GtkImage* icon_full;
	TrashAppletTrashHandler* trash_handler;
};

static gint TrashAppletWidgetsIconButton_private_offset;
static gpointer trash_applet_widgets_icon_button_parent_class = NULL;
static GType trash_applet_widgets_icon_button_type_id = 0;

static void trash_applet_widgets_icon_button_finalize (GObject * obj);

static inline gpointer
trash_applet_widgets_icon_button_get_instance_private (TrashAppletWidgetsIconButton* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletWidgetsIconButton_private_offset);
}

void
trash_applet_widgets_icon_button_set_icon_full (TrashAppletWidgetsIconButton* self,
                                                gboolean full)
{
	GtkImage* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	if (full) {
		GtkImage* _tmp1_;
		_tmp1_ = self->priv->icon_full;
		_tmp0_ = _tmp1_;
	} else {
		GtkImage* _tmp2_;
		_tmp2_ = self->priv->icon_empty;
		_tmp0_ = _tmp2_;
	}
	gtk_button_set_image ((GtkButton*) self, (GtkWidget*) _tmp0_);
}

static gpointer
_trash_applet_trash_handler_ref0 (gpointer self)
{
	return self ? trash_applet_trash_handler_ref (self) : NULL;
}

TrashAppletWidgetsIconButton*
trash_applet_widgets_icon_button_construct (GType object_type,
                                            TrashAppletTrashHandler* trash_handler)
{
	TrashAppletWidgetsIconButton * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	TrashAppletTrashHandler* _tmp2_;
	GtkImage* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* _tmp5_;
	g_return_val_if_fail (trash_handler != NULL, NULL);
	self = (TrashAppletWidgetsIconButton*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("user-trash-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->icon_empty);
	self->priv->icon_empty = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("user-trash-full-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->icon_full);
	self->priv->icon_full = _tmp1_;
	_tmp2_ = _trash_applet_trash_handler_ref0 (trash_handler);
	_trash_applet_trash_handler_unref0 (self->priv->trash_handler);
	self->priv->trash_handler = _tmp2_;
	_tmp3_ = self->priv->icon_empty;
	gtk_button_set_image ((GtkButton*) self, (GtkWidget*) _tmp3_);
	gtk_widget_set_tooltip_text ((GtkWidget*) self, "Trash");
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp4_, "flat");
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_remove_class (_tmp5_, "button");
	return self;
}

TrashAppletWidgetsIconButton*
trash_applet_widgets_icon_button_new (TrashAppletTrashHandler* trash_handler)
{
	return trash_applet_widgets_icon_button_construct (TRASH_APPLET_WIDGETS_TYPE_ICON_BUTTON, trash_handler);
}

static void
trash_applet_widgets_icon_button_class_init (TrashAppletWidgetsIconButtonClass * klass,
                                             gpointer klass_data)
{
	trash_applet_widgets_icon_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TrashAppletWidgetsIconButton_private_offset);
	G_OBJECT_CLASS (klass)->finalize = trash_applet_widgets_icon_button_finalize;
}

static void
trash_applet_widgets_icon_button_instance_init (TrashAppletWidgetsIconButton * self,
                                                gpointer klass)
{
	self->priv = trash_applet_widgets_icon_button_get_instance_private (self);
	self->priv->icon_empty = NULL;
	self->priv->icon_full = NULL;
}

static void
trash_applet_widgets_icon_button_finalize (GObject * obj)
{
	TrashAppletWidgetsIconButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_WIDGETS_TYPE_ICON_BUTTON, TrashAppletWidgetsIconButton);
	_g_object_unref0 (self->priv->icon_empty);
	_g_object_unref0 (self->priv->icon_full);
	_trash_applet_trash_handler_unref0 (self->priv->trash_handler);
	G_OBJECT_CLASS (trash_applet_widgets_icon_button_parent_class)->finalize (obj);
}

GType
trash_applet_widgets_icon_button_get_type (void)
{
	return trash_applet_widgets_icon_button_type_id;
}

GType
trash_applet_widgets_icon_button_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletWidgetsIconButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_widgets_icon_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletWidgetsIconButton), 0, (GInstanceInitFunc) trash_applet_widgets_icon_button_instance_init, NULL };
	trash_applet_widgets_icon_button_type_id = g_type_module_register_type (module, gtk_button_get_type (), "TrashAppletWidgetsIconButton", &g_define_type_info, 0);
	TrashAppletWidgetsIconButton_private_offset = sizeof (TrashAppletWidgetsIconButtonPrivate);
	return trash_applet_widgets_icon_button_type_id;
}

