/* TrashItem.c generated by valac 0.56.8, the Vala compiler
 * generated from TrashItem.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

enum  {
	TRASH_APPLET_WIDGETS_TRASH_ITEM_0_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_PROPERTIES
};
static GParamSpec* trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_DELETE_SIGNAL,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_RESTORE_SIGNAL,
	TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_SIGNALS
};
static guint trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_NUM_SIGNALS] = {0};

struct _TrashAppletWidgetsTrashItemPrivate {
	gboolean restoring;
	gchar* _file_path;
	gchar* _file_name;
	gboolean _is_directory;
	GDateTime* _deletion_time;
	GtkBox* file_container;
	GtkImage* file_icon;
	GtkLabel* display_text;
	GtkButton* restore_button;
	GtkButton* delete_button;
	GtkRevealer* info_revealer;
	GtkBox* info_container;
	GtkLabel* path_label;
	GtkLabel* date_label;
	GtkRevealer* revealer;
	GtkBox* revealer_container;
	GtkLabel* revealer_text;
	GtkBox* revealer_buttons;
	GtkButton* go_back_button;
	GtkButton* confirm_button;
};

static gint TrashAppletWidgetsTrashItem_private_offset;
static gpointer trash_applet_widgets_trash_item_parent_class = NULL;
static GType trash_applet_widgets_trash_item_type_id = 0;

static void trash_applet_widgets_trash_item_set_file_path (TrashAppletWidgetsTrashItem* self,
                                                    const gchar* value);
static void trash_applet_widgets_trash_item_set_file_name (TrashAppletWidgetsTrashItem* self,
                                                    const gchar* value);
static void trash_applet_widgets_trash_item_set_deletion_time (TrashAppletWidgetsTrashItem* self,
                                                        GDateTime* value);
static void trash_applet_widgets_trash_item_set_is_directory (TrashAppletWidgetsTrashItem* self,
                                                       gboolean value);
static void trash_applet_widgets_trash_item_apply_button_styles (TrashAppletWidgetsTrashItem* self);
static void trash_applet_widgets_trash_item_connect_signals (TrashAppletWidgetsTrashItem* self);
static void __lambda7_ (TrashAppletWidgetsTrashItem* self);
static void trash_applet_widgets_trash_item_show_confirmation (TrashAppletWidgetsTrashItem* self,
                                                        gboolean restore);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda8_ (TrashAppletWidgetsTrashItem* self);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda9_ (TrashAppletWidgetsTrashItem* self);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda10_ (TrashAppletWidgetsTrashItem* self);
static void ___lambda10__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void trash_applet_widgets_trash_item_finalize (GObject * obj);
static void _vala_trash_applet_widgets_trash_item_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_trash_applet_widgets_trash_item_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
trash_applet_widgets_trash_item_get_instance_private (TrashAppletWidgetsTrashItem* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletWidgetsTrashItem_private_offset);
}

/**
         * Constructor
         */
TrashAppletWidgetsTrashItem*
trash_applet_widgets_trash_item_construct (GType object_type,
                                           const gchar* file_path,
                                           const gchar* file_name,
                                           GIcon* glib_icon,
                                           GDateTime* deletion_time,
                                           gboolean is_directory)
{
	TrashAppletWidgetsTrashItem * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkImage* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkBox* _tmp13_;
	GtkImage* _tmp14_;
	GtkBox* _tmp15_;
	GtkLabel* _tmp16_;
	GtkBox* _tmp17_;
	GtkButton* _tmp18_;
	GtkBox* _tmp19_;
	GtkButton* _tmp20_;
	GtkRevealer* _tmp21_;
	GtkRevealer* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkBox* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	gchar* time = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkBox* _tmp40_;
	GtkLabel* _tmp41_;
	GtkBox* _tmp42_;
	GtkLabel* _tmp43_;
	GtkRevealer* _tmp44_;
	GtkBox* _tmp45_;
	GtkRevealer* _tmp46_;
	GtkRevealer* _tmp47_;
	GtkRevealer* _tmp48_;
	GtkBox* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkBox* _tmp52_;
	GtkButton* _tmp53_;
	GtkButton* _tmp54_;
	GtkBox* _tmp55_;
	GtkButton* _tmp56_;
	GtkBox* _tmp57_;
	GtkButton* _tmp58_;
	GtkBox* _tmp59_;
	GtkLabel* _tmp60_;
	GtkBox* _tmp61_;
	GtkBox* _tmp62_;
	GtkRevealer* _tmp63_;
	GtkBox* _tmp64_;
	GtkBox* _tmp65_;
	GtkRevealer* _tmp66_;
	GtkRevealer* _tmp67_;
	g_return_val_if_fail (file_path != NULL, NULL);
	g_return_val_if_fail (file_name != NULL, NULL);
	g_return_val_if_fail (glib_icon != NULL, NULL);
	g_return_val_if_fail (deletion_time != NULL, NULL);
	self = (TrashAppletWidgetsTrashItem*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 0, NULL);
	trash_applet_widgets_trash_item_set_file_path (self, file_path);
	trash_applet_widgets_trash_item_set_file_name (self, file_name);
	trash_applet_widgets_trash_item_set_deletion_time (self, deletion_time);
	trash_applet_widgets_trash_item_set_is_directory (self, is_directory);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "trash-item");
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->file_container);
	self->priv->file_container = _tmp1_;
	_tmp2_ = self->priv->file_container;
	g_object_set ((GtkWidget*) _tmp2_, "height-request", 32, NULL);
	_tmp3_ = (GtkImage*) gtk_image_new_from_gicon (glib_icon, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->file_icon);
	self->priv->file_icon = _tmp3_;
	_tmp4_ = (GtkLabel*) gtk_label_new (file_name);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->display_text);
	self->priv->display_text = _tmp4_;
	_tmp5_ = self->priv->display_text;
	gtk_label_set_max_width_chars (_tmp5_, 30);
	_tmp6_ = self->priv->display_text;
	gtk_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
	_tmp7_ = self->priv->display_text;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
	_tmp8_ = self->priv->display_text;
	gtk_label_set_justify (_tmp8_, GTK_JUSTIFY_LEFT);
	_tmp9_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->restore_button);
	self->priv->restore_button = _tmp9_;
	_tmp10_ = self->priv->restore_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _ ("Restore item"));
	_tmp11_ = (GtkButton*) gtk_button_new_from_icon_name ("user-trash-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->delete_button);
	self->priv->delete_button = _tmp11_;
	_tmp12_ = self->priv->delete_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _ ("Delete item"));
	_tmp13_ = self->priv->file_container;
	_tmp14_ = self->priv->file_icon;
	gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 5);
	_tmp15_ = self->priv->file_container;
	_tmp16_ = self->priv->display_text;
	gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
	_tmp17_ = self->priv->file_container;
	_tmp18_ = self->priv->delete_button;
	gtk_box_pack_end (_tmp17_, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 0);
	_tmp19_ = self->priv->file_container;
	_tmp20_ = self->priv->restore_button;
	gtk_box_pack_end (_tmp19_, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
	_tmp21_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->info_revealer);
	self->priv->info_revealer = _tmp21_;
	_tmp22_ = self->priv->info_revealer;
	gtk_revealer_set_transition_type (_tmp22_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp23_ = self->priv->info_revealer;
	gtk_revealer_set_reveal_child (_tmp23_, FALSE);
	_tmp24_ = self->priv->info_revealer;
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
	gtk_style_context_add_class (_tmp25_, "trash-info-revealer");
	_tmp26_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->info_container);
	self->priv->info_container = _tmp26_;
	_tmp27_ = g_strdup_printf (_ ("Path: %s"), file_path);
	_tmp28_ = _tmp27_;
	_tmp29_ = (GtkLabel*) gtk_label_new (_tmp28_);
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (self->priv->path_label);
	self->priv->path_label = _tmp29_;
	_g_free0 (_tmp28_);
	_tmp30_ = self->priv->path_label;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp30_, file_path);
	_tmp31_ = self->priv->path_label;
	gtk_label_set_ellipsize (_tmp31_, PANGO_ELLIPSIZE_END);
	_tmp32_ = self->priv->path_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_START);
	_tmp33_ = self->priv->path_label;
	gtk_label_set_justify (_tmp33_, GTK_JUSTIFY_LEFT);
	_tmp34_ = g_date_time_format (deletion_time, "%Y-%m-%d %H:%M %Z");
	time = _tmp34_;
	_tmp35_ = g_strdup_printf (_ ("Deleted on: %s"), time);
	_tmp36_ = _tmp35_;
	_tmp37_ = (GtkLabel*) gtk_label_new (_tmp36_);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->date_label);
	self->priv->date_label = _tmp37_;
	_g_free0 (_tmp36_);
	_tmp38_ = self->priv->date_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp38_, GTK_ALIGN_START);
	_tmp39_ = self->priv->date_label;
	gtk_label_set_justify (_tmp39_, GTK_JUSTIFY_LEFT);
	_tmp40_ = self->priv->info_container;
	_tmp41_ = self->priv->path_label;
	gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, TRUE, TRUE, (guint) 0);
	_tmp42_ = self->priv->info_container;
	_tmp43_ = self->priv->date_label;
	gtk_box_pack_start (_tmp42_, (GtkWidget*) _tmp43_, TRUE, TRUE, (guint) 0);
	_tmp44_ = self->priv->info_revealer;
	_tmp45_ = self->priv->info_container;
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
	_tmp46_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp46_);
	_g_object_unref0 (self->priv->revealer);
	self->priv->revealer = _tmp46_;
	_tmp47_ = self->priv->revealer;
	gtk_revealer_set_transition_type (_tmp47_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp48_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp48_, FALSE);
	_tmp49_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
	g_object_ref_sink (_tmp49_);
	_g_object_unref0 (self->priv->revealer_container);
	self->priv->revealer_container = _tmp49_;
	_tmp50_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp50_);
	_g_object_unref0 (self->priv->revealer_text);
	self->priv->revealer_text = _tmp50_;
	_tmp51_ = self->priv->revealer_text;
	g_object_set ((GtkWidget*) _tmp51_, "height-request", 20, NULL);
	_tmp52_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp52_);
	_g_object_unref0 (self->priv->revealer_buttons);
	self->priv->revealer_buttons = _tmp52_;
	_tmp53_ = (GtkButton*) gtk_button_new_with_label (_ ("No"));
	g_object_ref_sink (_tmp53_);
	_g_object_unref0 (self->priv->go_back_button);
	self->priv->go_back_button = _tmp53_;
	_tmp54_ = (GtkButton*) gtk_button_new_with_label (_ ("Yes"));
	g_object_ref_sink (_tmp54_);
	_g_object_unref0 (self->priv->confirm_button);
	self->priv->confirm_button = _tmp54_;
	_tmp55_ = self->priv->revealer_buttons;
	_tmp56_ = self->priv->go_back_button;
	gtk_box_pack_start (_tmp55_, (GtkWidget*) _tmp56_, TRUE, TRUE, (guint) 0);
	_tmp57_ = self->priv->revealer_buttons;
	_tmp58_ = self->priv->confirm_button;
	gtk_box_pack_end (_tmp57_, (GtkWidget*) _tmp58_, TRUE, TRUE, (guint) 0);
	_tmp59_ = self->priv->revealer_container;
	_tmp60_ = self->priv->revealer_text;
	gtk_box_pack_start (_tmp59_, (GtkWidget*) _tmp60_, TRUE, TRUE, (guint) 0);
	_tmp61_ = self->priv->revealer_container;
	_tmp62_ = self->priv->revealer_buttons;
	gtk_box_pack_end (_tmp61_, (GtkWidget*) _tmp62_, TRUE, TRUE, (guint) 0);
	_tmp63_ = self->priv->revealer;
	_tmp64_ = self->priv->revealer_container;
	gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
	trash_applet_widgets_trash_item_apply_button_styles (self);
	trash_applet_widgets_trash_item_connect_signals (self);
	_tmp65_ = self->priv->file_container;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp65_, TRUE, TRUE, (guint) 0);
	_tmp66_ = self->priv->revealer;
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp66_, FALSE, FALSE, (guint) 0);
	_tmp67_ = self->priv->info_revealer;
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp67_, FALSE, FALSE, (guint) 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_free0 (time);
	return self;
}

TrashAppletWidgetsTrashItem*
trash_applet_widgets_trash_item_new (const gchar* file_path,
                                     const gchar* file_name,
                                     GIcon* glib_icon,
                                     GDateTime* deletion_time,
                                     gboolean is_directory)
{
	return trash_applet_widgets_trash_item_construct (TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, file_path, file_name, glib_icon, deletion_time, is_directory);
}

void
trash_applet_widgets_trash_item_toggle_info_revealer (TrashAppletWidgetsTrashItem* self)
{
	GtkRevealer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->info_revealer;
	if (gtk_revealer_get_reveal_child (_tmp0_)) {
		GtkRevealer* _tmp1_;
		_tmp1_ = self->priv->info_revealer;
		gtk_revealer_set_reveal_child (_tmp1_, FALSE);
	} else {
		GtkRevealer* _tmp2_;
		_tmp2_ = self->priv->info_revealer;
		gtk_revealer_set_reveal_child (_tmp2_, TRUE);
	}
}

static void
trash_applet_widgets_trash_item_apply_button_styles (TrashAppletWidgetsTrashItem* self)
{
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkButton* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* _tmp16_;
	GtkStyleContext* _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->restore_button;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
	gtk_style_context_add_class (_tmp1_, "flat");
	_tmp2_ = self->priv->delete_button;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "flat");
	_tmp4_ = self->priv->go_back_button;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, "flat");
	_tmp6_ = self->priv->confirm_button;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "flat");
	_tmp8_ = self->priv->confirm_button;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, "destructive-action");
	_tmp10_ = self->priv->restore_button;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_remove_class (_tmp11_, "button");
	_tmp12_ = self->priv->delete_button;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_remove_class (_tmp13_, "button");
	_tmp14_ = self->priv->go_back_button;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_remove_class (_tmp15_, "button");
	_tmp16_ = self->priv->confirm_button;
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
	gtk_style_context_remove_class (_tmp17_, "button");
}

static void
__lambda7_ (TrashAppletWidgetsTrashItem* self)
{
	trash_applet_widgets_trash_item_show_confirmation (self, FALSE);
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda7_ ((TrashAppletWidgetsTrashItem*) self);
}

static void
__lambda8_ (TrashAppletWidgetsTrashItem* self)
{
	trash_applet_widgets_trash_item_show_confirmation (self, TRUE);
}

static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda8_ ((TrashAppletWidgetsTrashItem*) self);
}

static void
__lambda9_ (TrashAppletWidgetsTrashItem* self)
{
	if (self->priv->restoring) {
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		_tmp0_ = self->priv->_file_name;
		_tmp1_ = self->priv->_file_path;
		g_signal_emit (self, trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_RESTORE_SIGNAL], 0, _tmp0_, _tmp1_);
	} else {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_file_name;
		g_signal_emit (self, trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_DELETE_SIGNAL], 0, _tmp2_);
	}
}

static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda9_ ((TrashAppletWidgetsTrashItem*) self);
}

static void
__lambda10_ (TrashAppletWidgetsTrashItem* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkRevealer* _tmp2_;
	_tmp0_ = self->priv->restore_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
	_tmp1_ = self->priv->delete_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
}

static void
___lambda10__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda10_ ((TrashAppletWidgetsTrashItem*) self);
}

static void
trash_applet_widgets_trash_item_connect_signals (TrashAppletWidgetsTrashItem* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->delete_button;
	g_signal_connect_object (_tmp0_, "clicked", (GCallback) ___lambda7__gtk_button_clicked, self, 0);
	_tmp1_ = self->priv->restore_button;
	g_signal_connect_object (_tmp1_, "clicked", (GCallback) ___lambda8__gtk_button_clicked, self, 0);
	_tmp2_ = self->priv->confirm_button;
	g_signal_connect_object (_tmp2_, "clicked", (GCallback) ___lambda9__gtk_button_clicked, self, 0);
	_tmp3_ = self->priv->go_back_button;
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) ___lambda10__gtk_button_clicked, self, 0);
}

static void
trash_applet_widgets_trash_item_show_confirmation (TrashAppletWidgetsTrashItem* self,
                                                   gboolean restore)
{
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkRevealer* _tmp8_;
	g_return_if_fail (self != NULL);
	self->priv->restoring = restore;
	if (restore) {
		GtkLabel* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->revealer_text;
		_tmp1_ = g_strdup_printf ("<b>%s</b>", _ ("Restore this item?"));
		_tmp2_ = _tmp1_;
		gtk_label_set_markup (_tmp0_, _tmp2_);
		_g_free0 (_tmp2_);
	} else {
		GtkLabel* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = self->priv->revealer_text;
		_tmp4_ = g_strdup_printf ("<b>%s</b>", _ ("Delete this item?"));
		_tmp5_ = _tmp4_;
		gtk_label_set_markup (_tmp3_, _tmp5_);
		_g_free0 (_tmp5_);
	}
	_tmp6_ = self->priv->restore_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
	_tmp7_ = self->priv->delete_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
	_tmp8_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp8_, TRUE);
}

const gchar*
trash_applet_widgets_trash_item_get_file_path (TrashAppletWidgetsTrashItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_file_path;
	result = _tmp0_;
	return result;
}

static void
trash_applet_widgets_trash_item_set_file_path (TrashAppletWidgetsTrashItem* self,
                                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = trash_applet_widgets_trash_item_get_file_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_file_path);
		self->priv->_file_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY]);
	}
}

const gchar*
trash_applet_widgets_trash_item_get_file_name (TrashAppletWidgetsTrashItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_file_name;
	result = _tmp0_;
	return result;
}

static void
trash_applet_widgets_trash_item_set_file_name (TrashAppletWidgetsTrashItem* self,
                                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = trash_applet_widgets_trash_item_get_file_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_file_name);
		self->priv->_file_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY]);
	}
}

gboolean
trash_applet_widgets_trash_item_get_is_directory (TrashAppletWidgetsTrashItem* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_directory;
	return result;
}

static void
trash_applet_widgets_trash_item_set_is_directory (TrashAppletWidgetsTrashItem* self,
                                                  gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = trash_applet_widgets_trash_item_get_is_directory (self);
	if (old_value != value) {
		self->priv->_is_directory = value;
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY]);
	}
}

GDateTime*
trash_applet_widgets_trash_item_get_deletion_time (TrashAppletWidgetsTrashItem* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_deletion_time;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

static void
trash_applet_widgets_trash_item_set_deletion_time (TrashAppletWidgetsTrashItem* self,
                                                   GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = trash_applet_widgets_trash_item_get_deletion_time (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_deletion_time);
		self->priv->_deletion_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
trash_applet_widgets_trash_item_class_init (TrashAppletWidgetsTrashItemClass * klass,
                                            gpointer klass_data)
{
	trash_applet_widgets_trash_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TrashAppletWidgetsTrashItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_trash_applet_widgets_trash_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_trash_applet_widgets_trash_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = trash_applet_widgets_trash_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY] = g_param_spec_string ("file-path", "file-path", "file-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY] = g_param_spec_string ("file-name", "file-name", "file-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY] = g_param_spec_boolean ("is-directory", "is-directory", "is-directory", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY, trash_applet_widgets_trash_item_properties[TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY] = g_param_spec_boxed ("deletion-time", "deletion-time", "deletion-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_DELETE_SIGNAL] = g_signal_new ("on-delete", TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	trash_applet_widgets_trash_item_signals[TRASH_APPLET_WIDGETS_TRASH_ITEM_ON_RESTORE_SIGNAL] = g_signal_new ("on-restore", TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}

static void
trash_applet_widgets_trash_item_instance_init (TrashAppletWidgetsTrashItem * self,
                                               gpointer klass)
{
	self->priv = trash_applet_widgets_trash_item_get_instance_private (self);
	self->priv->restoring = FALSE;
	self->priv->file_container = NULL;
	self->priv->file_icon = NULL;
	self->priv->display_text = NULL;
	self->priv->restore_button = NULL;
	self->priv->delete_button = NULL;
	self->priv->info_revealer = NULL;
	self->priv->info_container = NULL;
	self->priv->path_label = NULL;
	self->priv->date_label = NULL;
	self->priv->revealer = NULL;
	self->priv->revealer_container = NULL;
	self->priv->revealer_text = NULL;
	self->priv->revealer_buttons = NULL;
	self->priv->go_back_button = NULL;
	self->priv->confirm_button = NULL;
}

static void
trash_applet_widgets_trash_item_finalize (GObject * obj)
{
	TrashAppletWidgetsTrashItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem);
	_g_free0 (self->priv->_file_path);
	_g_free0 (self->priv->_file_name);
	_g_date_time_unref0 (self->priv->_deletion_time);
	_g_object_unref0 (self->priv->file_container);
	_g_object_unref0 (self->priv->file_icon);
	_g_object_unref0 (self->priv->display_text);
	_g_object_unref0 (self->priv->restore_button);
	_g_object_unref0 (self->priv->delete_button);
	_g_object_unref0 (self->priv->info_revealer);
	_g_object_unref0 (self->priv->info_container);
	_g_object_unref0 (self->priv->path_label);
	_g_object_unref0 (self->priv->date_label);
	_g_object_unref0 (self->priv->revealer);
	_g_object_unref0 (self->priv->revealer_container);
	_g_object_unref0 (self->priv->revealer_text);
	_g_object_unref0 (self->priv->revealer_buttons);
	_g_object_unref0 (self->priv->go_back_button);
	_g_object_unref0 (self->priv->confirm_button);
	G_OBJECT_CLASS (trash_applet_widgets_trash_item_parent_class)->finalize (obj);
}

GType
trash_applet_widgets_trash_item_get_type (void)
{
	return trash_applet_widgets_trash_item_type_id;
}

GType
trash_applet_widgets_trash_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletWidgetsTrashItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_widgets_trash_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletWidgetsTrashItem), 0, (GInstanceInitFunc) trash_applet_widgets_trash_item_instance_init, NULL };
	trash_applet_widgets_trash_item_type_id = g_type_module_register_type (module, gtk_box_get_type (), "TrashAppletWidgetsTrashItem", &g_define_type_info, 0);
	TrashAppletWidgetsTrashItem_private_offset = sizeof (TrashAppletWidgetsTrashItemPrivate);
	return trash_applet_widgets_trash_item_type_id;
}

static void
_vala_trash_applet_widgets_trash_item_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	TrashAppletWidgetsTrashItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem);
	switch (property_id) {
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY:
		g_value_set_string (value, trash_applet_widgets_trash_item_get_file_path (self));
		break;
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY:
		g_value_set_string (value, trash_applet_widgets_trash_item_get_file_name (self));
		break;
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY:
		g_value_set_boolean (value, trash_applet_widgets_trash_item_get_is_directory (self));
		break;
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY:
		g_value_set_boxed (value, trash_applet_widgets_trash_item_get_deletion_time (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_trash_applet_widgets_trash_item_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	TrashAppletWidgetsTrashItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem);
	switch (property_id) {
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_PATH_PROPERTY:
		trash_applet_widgets_trash_item_set_file_path (self, g_value_get_string (value));
		break;
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_FILE_NAME_PROPERTY:
		trash_applet_widgets_trash_item_set_file_name (self, g_value_get_string (value));
		break;
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_IS_DIRECTORY_PROPERTY:
		trash_applet_widgets_trash_item_set_is_directory (self, g_value_get_boolean (value));
		break;
		case TRASH_APPLET_WIDGETS_TRASH_ITEM_DELETION_TIME_PROPERTY:
		trash_applet_widgets_trash_item_set_deletion_time (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

