/* TrashStoreWidget.c generated by valac 0.56.8, the Vala compiler
 * generated from TrashStoreWidget.vala, do not modify */

/*
 * This file is part of UbuntuBudgie
 *
 * Copyright 2019 Evan Maddock, 2021 Ubuntu Budgie Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "trashapplet.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

enum  {
	TRASH_APPLET_WIDGETS_TRASH_STORE_WIDGET_0_PROPERTY,
	TRASH_APPLET_WIDGETS_TRASH_STORE_WIDGET_NUM_PROPERTIES
};
static GParamSpec* trash_applet_widgets_trash_store_widget_properties[TRASH_APPLET_WIDGETS_TRASH_STORE_WIDGET_NUM_PROPERTIES];
#define _trash_applet_trash_store_unref0(var) ((var == NULL) ? NULL : (var = (trash_applet_trash_store_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TrashAppletWidgetsTrashStoreWidgetPrivate {
	TrashAppletTrashStore* trash_store;
	GHashTable* trash_items;
	gboolean restoring;
	GtkBox* store_header;
	GtkImage* drive_icon;
	GtkLabel* store_label;
	GtkButton* restore_button;
	GtkButton* delete_button;
	GtkRevealer* revealer;
	GtkBox* revealer_container;
	GtkLabel* revealer_text;
	GtkBox* revealer_buttons;
	GtkButton* go_back_button;
	GtkButton* confirm_button;
	GtkListBox* file_box;
};

static gint TrashAppletWidgetsTrashStoreWidget_private_offset;
static gpointer trash_applet_widgets_trash_store_widget_parent_class = NULL;
static GType trash_applet_widgets_trash_store_widget_type_id = 0;

static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void trash_applet_widgets_trash_store_widget_set_buttons_sensitive (TrashAppletWidgetsTrashStoreWidget* self,
                                                                    gboolean is_sensitive);
static void trash_applet_widgets_trash_store_widget_apply_button_styles (TrashAppletWidgetsTrashStoreWidget* self);
static void trash_applet_widgets_trash_store_widget_connect_signals (TrashAppletWidgetsTrashStoreWidget* self);
static void __lambda11_ (TrashAppletWidgetsTrashStoreWidget* self,
                  const gchar* file_name);
static void ___lambda11__trash_applet_widgets_trash_item_on_delete (TrashAppletWidgetsTrashItem* _sender,
                                                             const gchar* file_name,
                                                             gpointer self);
static void __lambda12_ (TrashAppletWidgetsTrashStoreWidget* self,
                  const gchar* file_name,
                  const gchar* restore_path);
static void ___lambda12__trash_applet_widgets_trash_item_on_restore (TrashAppletWidgetsTrashItem* _sender,
                                                              const gchar* file_name,
                                                              const gchar* restore_path,
                                                              gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_type (TrashAppletWidgetsTrashStoreWidget* self,
                                                           GtkListBoxRow* row1,
                                                           GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_type_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                   GtkListBoxRow* row2,
                                                                                   gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_name (TrashAppletWidgetsTrashStoreWidget* self,
                                                           GtkListBoxRow* row1,
                                                           GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_name_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                   GtkListBoxRow* row2,
                                                                                   gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_newest (TrashAppletWidgetsTrashStoreWidget* self,
                                                             GtkListBoxRow* row1,
                                                             GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_newest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                     GtkListBoxRow* row2,
                                                                                     gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_oldest (TrashAppletWidgetsTrashStoreWidget* self,
                                                             GtkListBoxRow* row1,
                                                             GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_oldest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                     GtkListBoxRow* row2,
                                                                                     gpointer self);
static gint trash_applet_widgets_trash_store_widget_sort_by_name_reverse (TrashAppletWidgetsTrashStoreWidget* self,
                                                                   GtkListBoxRow* row1,
                                                                   GtkListBoxRow* row2);
static gint _trash_applet_widgets_trash_store_widget_sort_by_name_reverse_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                           GtkListBoxRow* row2,
                                                                                           gpointer self);
static void _trash_applet_widgets_trash_store_widget_add_trash_item_trash_applet_trash_store_trash_added (TrashAppletTrashStore* _sender,
                                                                                                   const gchar* file_name,
                                                                                                   const gchar* file_path,
                                                                                                   GIcon* file_icon,
                                                                                                   GDateTime* deletion_time,
                                                                                                   gboolean is_directory,
                                                                                                   gpointer self);
static void _trash_applet_widgets_trash_store_widget_remove_trash_item_trash_applet_trash_store_trash_removed (TrashAppletTrashStore* _sender,
                                                                                                        const gchar* file_name,
                                                                                                        gboolean is_empty,
                                                                                                        gpointer self);
static void __lambda13_ (TrashAppletWidgetsTrashStoreWidget* self);
static void trash_applet_widgets_trash_store_widget_show_confirmation (TrashAppletWidgetsTrashStoreWidget* self,
                                                                gboolean restore);
static void ___lambda13__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda14_ (TrashAppletWidgetsTrashStoreWidget* self);
static void ___lambda14__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda15_ (TrashAppletWidgetsTrashStoreWidget* self);
static void ___lambda16_ (TrashAppletWidgetsTrashStoreWidget* self,
                   TrashAppletWidgetsTrashItem* item);
static void ____lambda16__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda17_ (TrashAppletWidgetsTrashStoreWidget* self,
                   TrashAppletWidgetsTrashItem* item);
static void ____lambda17__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda15__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda18_ (TrashAppletWidgetsTrashStoreWidget* self);
static void ___lambda18__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda19_ (TrashAppletWidgetsTrashStoreWidget* self,
                  GtkListBoxRow* row);
static void ___lambda19__gtk_list_box_row_activated (GtkListBox* _sender,
                                              GtkListBoxRow* row,
                                              gpointer self);
static void trash_applet_widgets_trash_store_widget_finalize (GObject * obj);

static inline gpointer
trash_applet_widgets_trash_store_widget_get_instance_private (TrashAppletWidgetsTrashStoreWidget* self)
{
	return G_STRUCT_MEMBER_P (self, TrashAppletWidgetsTrashStoreWidget_private_offset);
}

static gpointer
_trash_applet_trash_store_ref0 (gpointer self)
{
	return self ? trash_applet_trash_store_ref (self) : NULL;
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

TrashAppletWidgetsTrashStoreWidget*
trash_applet_widgets_trash_store_widget_construct (GType object_type,
                                                   TrashAppletTrashStore* trash_store,
                                                   TrashAppletWidgetsSortType sort_type)
{
	TrashAppletWidgetsTrashStoreWidget * self = NULL;
	TrashAppletTrashStore* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GIcon* _tmp12_;
	GIcon* _tmp13_;
	GtkImage* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkBox* _tmp22_;
	GtkImage* _tmp23_;
	GtkBox* _tmp24_;
	GtkLabel* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkBox* _tmp30_;
	GtkButton* _tmp31_;
	GtkBox* _tmp32_;
	GtkButton* _tmp33_;
	GtkRevealer* _tmp34_;
	GtkRevealer* _tmp35_;
	GtkRevealer* _tmp36_;
	GtkBox* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkBox* _tmp40_;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkBox* _tmp43_;
	GtkButton* _tmp44_;
	GtkBox* _tmp45_;
	GtkButton* _tmp46_;
	GtkBox* _tmp47_;
	GtkLabel* _tmp48_;
	GtkBox* _tmp49_;
	GtkBox* _tmp50_;
	GtkRevealer* _tmp51_;
	GtkBox* _tmp52_;
	GtkListBox* _tmp53_;
	GtkListBox* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkListBox* _tmp56_;
	GtkStyleContext* _tmp57_;
	GtkListBox* _tmp58_;
	GtkListBox* _tmp59_;
	GtkBox* _tmp60_;
	GtkRevealer* _tmp61_;
	GtkListBox* _tmp62_;
	g_return_val_if_fail (trash_store != NULL, NULL);
	self = (TrashAppletWidgetsTrashStoreWidget*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 0, NULL);
	_tmp0_ = _trash_applet_trash_store_ref0 (trash_store);
	_trash_applet_trash_store_unref0 (self->priv->trash_store);
	self->priv->trash_store = _tmp0_;
	_tmp1_ = g_str_hash;
	_tmp2_ = g_str_equal;
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->trash_items);
	self->priv->trash_items = _tmp3_;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp4_, "trash-store-widget");
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->store_header);
	self->priv->store_header = _tmp5_;
	_tmp6_ = self->priv->store_header;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "trash-store-header");
	_tmp8_ = self->priv->store_header;
	g_object_set ((GtkWidget*) _tmp8_, "height-request", 32, NULL);
	_tmp9_ = self->priv->store_header;
	_tmp10_ = trash_applet_trash_store_get_drive_name (trash_store);
	_tmp11_ = _tmp10_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _tmp11_);
	_g_free0 (_tmp11_);
	_tmp12_ = trash_applet_trash_store_get_drive_icon (trash_store);
	_tmp13_ = _tmp12_;
	_tmp14_ = (GtkImage*) gtk_image_new_from_gicon (_tmp13_, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->drive_icon);
	self->priv->drive_icon = _tmp14_;
	_g_object_unref0 (_tmp13_);
	_tmp15_ = trash_applet_trash_store_get_drive_name (trash_store);
	_tmp16_ = _tmp15_;
	_tmp17_ = (GtkLabel*) gtk_label_new (_tmp16_);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->store_label);
	self->priv->store_label = _tmp17_;
	_g_free0 (_tmp16_);
	_tmp18_ = self->priv->store_label;
	gtk_label_set_max_width_chars (_tmp18_, 30);
	_tmp19_ = self->priv->store_label;
	gtk_label_set_ellipsize (_tmp19_, PANGO_ELLIPSIZE_END);
	_tmp20_ = self->priv->store_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
	_tmp21_ = self->priv->store_label;
	gtk_label_set_justify (_tmp21_, GTK_JUSTIFY_LEFT);
	_tmp22_ = self->priv->store_header;
	_tmp23_ = self->priv->drive_icon;
	gtk_box_pack_start (_tmp22_, (GtkWidget*) _tmp23_, FALSE, FALSE, (guint) 10);
	_tmp24_ = self->priv->store_header;
	_tmp25_ = self->priv->store_label;
	gtk_box_pack_start (_tmp24_, (GtkWidget*) _tmp25_, TRUE, TRUE, (guint) 0);
	_tmp26_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->restore_button);
	self->priv->restore_button = _tmp26_;
	_tmp27_ = self->priv->restore_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _ ("Restore all items"));
	_tmp28_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-all-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->delete_button);
	self->priv->delete_button = _tmp28_;
	_tmp29_ = self->priv->delete_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _ ("Delete all items"));
	trash_applet_widgets_trash_store_widget_set_buttons_sensitive (self, FALSE);
	_tmp30_ = self->priv->store_header;
	_tmp31_ = self->priv->delete_button;
	gtk_box_pack_end (_tmp30_, (GtkWidget*) _tmp31_, FALSE, FALSE, (guint) 0);
	_tmp32_ = self->priv->store_header;
	_tmp33_ = self->priv->restore_button;
	gtk_box_pack_end (_tmp32_, (GtkWidget*) _tmp33_, FALSE, FALSE, (guint) 0);
	_tmp34_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->priv->revealer);
	self->priv->revealer = _tmp34_;
	_tmp35_ = self->priv->revealer;
	gtk_revealer_set_transition_type (_tmp35_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp36_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp36_, FALSE);
	_tmp37_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->revealer_container);
	self->priv->revealer_container = _tmp37_;
	_tmp38_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->priv->revealer_text);
	self->priv->revealer_text = _tmp38_;
	_tmp39_ = self->priv->revealer_text;
	g_object_set ((GtkWidget*) _tmp39_, "height-request", 20, NULL);
	_tmp40_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp40_);
	_g_object_unref0 (self->priv->revealer_buttons);
	self->priv->revealer_buttons = _tmp40_;
	_tmp41_ = (GtkButton*) gtk_button_new_with_label (_ ("No"));
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->go_back_button);
	self->priv->go_back_button = _tmp41_;
	_tmp42_ = (GtkButton*) gtk_button_new_with_label (_ ("Yes"));
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->confirm_button);
	self->priv->confirm_button = _tmp42_;
	_tmp43_ = self->priv->revealer_buttons;
	_tmp44_ = self->priv->go_back_button;
	gtk_box_pack_start (_tmp43_, (GtkWidget*) _tmp44_, TRUE, TRUE, (guint) 0);
	_tmp45_ = self->priv->revealer_buttons;
	_tmp46_ = self->priv->confirm_button;
	gtk_box_pack_end (_tmp45_, (GtkWidget*) _tmp46_, TRUE, TRUE, (guint) 0);
	_tmp47_ = self->priv->revealer_container;
	_tmp48_ = self->priv->revealer_text;
	gtk_box_pack_start (_tmp47_, (GtkWidget*) _tmp48_, TRUE, TRUE, (guint) 0);
	_tmp49_ = self->priv->revealer_container;
	_tmp50_ = self->priv->revealer_buttons;
	gtk_box_pack_end (_tmp49_, (GtkWidget*) _tmp50_, TRUE, TRUE, (guint) 0);
	_tmp51_ = self->priv->revealer;
	_tmp52_ = self->priv->revealer_container;
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
	_tmp53_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp53_);
	_g_object_unref0 (self->priv->file_box);
	self->priv->file_box = _tmp53_;
	_tmp54_ = self->priv->file_box;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	gtk_style_context_add_class (_tmp55_, "trash-file-box");
	_tmp56_ = self->priv->file_box;
	_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) _tmp56_);
	gtk_style_context_add_class (_tmp57_, "empty");
	_tmp58_ = self->priv->file_box;
	gtk_list_box_set_activate_on_single_click (_tmp58_, TRUE);
	_tmp59_ = self->priv->file_box;
	gtk_list_box_set_selection_mode (_tmp59_, GTK_SELECTION_NONE);
	trash_applet_widgets_trash_store_widget_set_sort_type (self, sort_type);
	trash_applet_widgets_trash_store_widget_apply_button_styles (self);
	trash_applet_widgets_trash_store_widget_connect_signals (self);
	_tmp60_ = self->priv->store_header;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp60_, TRUE, TRUE, (guint) 0);
	_tmp61_ = self->priv->revealer;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp61_, FALSE, FALSE, (guint) 0);
	_tmp62_ = self->priv->file_box;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp62_, TRUE, TRUE, (guint) 0);
	gtk_widget_show_all ((GtkWidget*) self);
	return self;
}

TrashAppletWidgetsTrashStoreWidget*
trash_applet_widgets_trash_store_widget_new (TrashAppletTrashStore* trash_store,
                                             TrashAppletWidgetsSortType sort_type)
{
	return trash_applet_widgets_trash_store_widget_construct (TRASH_APPLET_WIDGETS_TYPE_TRASH_STORE_WIDGET, trash_store, sort_type);
}

/**
         * Add a new trash item.
         * 
         * @param info The FileInfo for the newly trashed file
         * @param old_path The path that the file came from
         */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda11_ (TrashAppletWidgetsTrashStoreWidget* self,
             const gchar* file_name)
{
	TrashAppletTrashStore* _tmp0_;
	g_return_if_fail (file_name != NULL);
	_tmp0_ = self->priv->trash_store;
	trash_applet_trash_store_delete_file (_tmp0_, file_name);
}

static void
___lambda11__trash_applet_widgets_trash_item_on_delete (TrashAppletWidgetsTrashItem* _sender,
                                                        const gchar* file_name,
                                                        gpointer self)
{
	__lambda11_ ((TrashAppletWidgetsTrashStoreWidget*) self, file_name);
}

static void
__lambda12_ (TrashAppletWidgetsTrashStoreWidget* self,
             const gchar* file_name,
             const gchar* restore_path)
{
	TrashAppletTrashStore* _tmp0_;
	g_return_if_fail (file_name != NULL);
	g_return_if_fail (restore_path != NULL);
	_tmp0_ = self->priv->trash_store;
	trash_applet_trash_store_restore_file (_tmp0_, file_name, restore_path);
}

static void
___lambda12__trash_applet_widgets_trash_item_on_restore (TrashAppletWidgetsTrashItem* _sender,
                                                         const gchar* file_name,
                                                         const gchar* restore_path,
                                                         gpointer self)
{
	__lambda12_ ((TrashAppletWidgetsTrashStoreWidget*) self, file_name, restore_path);
}

void
trash_applet_widgets_trash_store_widget_add_trash_item (TrashAppletWidgetsTrashStoreWidget* self,
                                                        const gchar* file_name,
                                                        const gchar* file_path,
                                                        GIcon* file_icon,
                                                        GDateTime* deletion_time,
                                                        gboolean is_directory)
{
	TrashAppletWidgetsTrashItem* item = NULL;
	TrashAppletWidgetsTrashItem* _tmp0_;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkStyleContext* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_name != NULL);
	g_return_if_fail (file_path != NULL);
	g_return_if_fail (file_icon != NULL);
	g_return_if_fail (deletion_time != NULL);
	_tmp0_ = trash_applet_widgets_trash_item_new (file_path, file_name, file_icon, deletion_time, is_directory);
	g_object_ref_sink (_tmp0_);
	item = _tmp0_;
	_tmp1_ = self->priv->trash_items;
	_tmp2_ = g_strdup (file_name);
	_tmp3_ = _g_object_ref0 (item);
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
	_tmp4_ = self->priv->file_box;
	gtk_list_box_insert (_tmp4_, (GtkWidget*) item, -1);
	_tmp5_ = self->priv->file_box;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_remove_class (_tmp6_, "empty");
	trash_applet_widgets_trash_store_widget_set_buttons_sensitive (self, TRUE);
	g_signal_connect_object (item, "on-delete", (GCallback) ___lambda11__trash_applet_widgets_trash_item_on_delete, self, 0);
	g_signal_connect_object (item, "on-restore", (GCallback) ___lambda12__trash_applet_widgets_trash_item_on_restore, self, 0);
	_g_object_unref0 (item);
}

/**
         * Remove an item from the trash view.
         * 
         * @param file_name The name of the file to remove
         */
void
trash_applet_widgets_trash_store_widget_remove_trash_item (TrashAppletWidgetsTrashStoreWidget* self,
                                                           const gchar* file_name,
                                                           gboolean is_empty)
{
	TrashAppletWidgetsTrashItem* item = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	TrashAppletWidgetsTrashItem* _tmp2_;
	GtkListBox* _tmp3_;
	TrashAppletWidgetsTrashItem* _tmp4_;
	GtkContainer* _tmp5_;
	GHashTable* _tmp6_;
	GHashTable* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_name != NULL);
	_tmp0_ = self->priv->trash_items;
	_tmp1_ = g_hash_table_lookup (_tmp0_, file_name);
	_tmp2_ = _g_object_ref0 ((TrashAppletWidgetsTrashItem*) _tmp1_);
	item = _tmp2_;
	_tmp3_ = self->priv->file_box;
	_tmp4_ = item;
	_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
	gtk_container_remove ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->trash_items;
	g_hash_table_remove (_tmp6_, file_name);
	_tmp7_ = self->priv->trash_items;
	if (g_hash_table_size (_tmp7_) == ((guint) 0)) {
		GtkListBox* _tmp8_;
		GtkStyleContext* _tmp9_;
		_tmp8_ = self->priv->file_box;
		_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
		gtk_style_context_add_class (_tmp9_, "empty");
		trash_applet_widgets_trash_store_widget_set_buttons_sensitive (self, FALSE);
	}
	_g_object_unref0 (item);
}

gchar*
trash_applet_widgets_trash_store_widget_get_name (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->store_label;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_type_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                              GtkListBoxRow* row2,
                                                                              gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_type ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
	return result;
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_name_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                              GtkListBoxRow* row2,
                                                                              gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_name ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
	return result;
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_newest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                GtkListBoxRow* row2,
                                                                                gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_newest ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
	return result;
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_oldest_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                GtkListBoxRow* row2,
                                                                                gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_oldest ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
	return result;
}

static gint
_trash_applet_widgets_trash_store_widget_sort_by_name_reverse_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                      GtkListBoxRow* row2,
                                                                                      gpointer self)
{
	gint result;
	result = trash_applet_widgets_trash_store_widget_sort_by_name_reverse ((TrashAppletWidgetsTrashStoreWidget*) self, row1, row2);
	return result;
}

void
trash_applet_widgets_trash_store_widget_set_sort_type (TrashAppletWidgetsTrashStoreWidget* self,
                                                       TrashAppletWidgetsSortType type)
{
	g_return_if_fail (self != NULL);
	switch (type) {
		case TRASH_APPLET_WIDGETS_SORT_TYPE_TYPE:
		{
			GtkListBox* _tmp0_;
			_tmp0_ = self->priv->file_box;
			gtk_list_box_set_sort_func (_tmp0_, _trash_applet_widgets_trash_store_widget_sort_by_type_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
			break;
		}
		case TRASH_APPLET_WIDGETS_SORT_TYPE_ALPHABETICAL:
		{
			GtkListBox* _tmp1_;
			_tmp1_ = self->priv->file_box;
			gtk_list_box_set_sort_func (_tmp1_, _trash_applet_widgets_trash_store_widget_sort_by_name_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
			break;
		}
		case TRASH_APPLET_WIDGETS_SORT_TYPE_NEWEST_FIRST:
		{
			GtkListBox* _tmp2_;
			_tmp2_ = self->priv->file_box;
			gtk_list_box_set_sort_func (_tmp2_, _trash_applet_widgets_trash_store_widget_sort_by_newest_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
			break;
		}
		case TRASH_APPLET_WIDGETS_SORT_TYPE_OLDEST_FIRST:
		{
			GtkListBox* _tmp3_;
			_tmp3_ = self->priv->file_box;
			gtk_list_box_set_sort_func (_tmp3_, _trash_applet_widgets_trash_store_widget_sort_by_oldest_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
			break;
		}
		case TRASH_APPLET_WIDGETS_SORT_TYPE_REVERSE_ALPHABETICAL:
		{
			GtkListBox* _tmp4_;
			_tmp4_ = self->priv->file_box;
			gtk_list_box_set_sort_func (_tmp4_, _trash_applet_widgets_trash_store_widget_sort_by_name_reverse_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
			break;
		}
		default:
		break;
	}
}

static void
trash_applet_widgets_trash_store_widget_apply_button_styles (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkButton* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* _tmp16_;
	GtkStyleContext* _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->restore_button;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
	gtk_style_context_add_class (_tmp1_, "flat");
	_tmp2_ = self->priv->delete_button;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "flat");
	_tmp4_ = self->priv->go_back_button;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, "flat");
	_tmp6_ = self->priv->confirm_button;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "flat");
	_tmp8_ = self->priv->confirm_button;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, "destructive-action");
	_tmp10_ = self->priv->restore_button;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_remove_class (_tmp11_, "button");
	_tmp12_ = self->priv->delete_button;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_remove_class (_tmp13_, "button");
	_tmp14_ = self->priv->go_back_button;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_remove_class (_tmp15_, "button");
	_tmp16_ = self->priv->confirm_button;
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
	gtk_style_context_remove_class (_tmp17_, "button");
}

static void
_trash_applet_widgets_trash_store_widget_add_trash_item_trash_applet_trash_store_trash_added (TrashAppletTrashStore* _sender,
                                                                                              const gchar* file_name,
                                                                                              const gchar* file_path,
                                                                                              GIcon* file_icon,
                                                                                              GDateTime* deletion_time,
                                                                                              gboolean is_directory,
                                                                                              gpointer self)
{
	trash_applet_widgets_trash_store_widget_add_trash_item ((TrashAppletWidgetsTrashStoreWidget*) self, file_name, file_path, file_icon, deletion_time, is_directory);
}

static void
_trash_applet_widgets_trash_store_widget_remove_trash_item_trash_applet_trash_store_trash_removed (TrashAppletTrashStore* _sender,
                                                                                                   const gchar* file_name,
                                                                                                   gboolean is_empty,
                                                                                                   gpointer self)
{
	trash_applet_widgets_trash_store_widget_remove_trash_item ((TrashAppletWidgetsTrashStoreWidget*) self, file_name, is_empty);
}

static void
__lambda13_ (TrashAppletWidgetsTrashStoreWidget* self)
{
	trash_applet_widgets_trash_store_widget_show_confirmation (self, FALSE);
}

static void
___lambda13__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda13_ ((TrashAppletWidgetsTrashStoreWidget*) self);
}

static void
__lambda14_ (TrashAppletWidgetsTrashStoreWidget* self)
{
	trash_applet_widgets_trash_store_widget_show_confirmation (self, TRUE);
}

static void
___lambda14__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda14_ ((TrashAppletWidgetsTrashStoreWidget*) self);
}

static void
___lambda16_ (TrashAppletWidgetsTrashStoreWidget* self,
              TrashAppletWidgetsTrashItem* item)
{
	TrashAppletTrashStore* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->trash_store;
	_tmp1_ = trash_applet_widgets_trash_item_get_file_name (item);
	_tmp2_ = _tmp1_;
	_tmp3_ = trash_applet_widgets_trash_item_get_file_path (item);
	_tmp4_ = _tmp3_;
	trash_applet_trash_store_restore_file (_tmp0_, _tmp2_, _tmp4_);
}

static void
____lambda16__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda16_ ((TrashAppletWidgetsTrashStoreWidget*) self, (TrashAppletWidgetsTrashItem*) data);
}

static void
___lambda17_ (TrashAppletWidgetsTrashStoreWidget* self,
              TrashAppletWidgetsTrashItem* item)
{
	TrashAppletTrashStore* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->trash_store;
	_tmp1_ = trash_applet_widgets_trash_item_get_file_name (item);
	_tmp2_ = _tmp1_;
	trash_applet_trash_store_delete_file (_tmp0_, _tmp2_);
}

static void
____lambda17__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda17_ ((TrashAppletWidgetsTrashStoreWidget*) self, (TrashAppletWidgetsTrashItem*) data);
}

static void
__lambda15_ (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkRevealer* _tmp6_;
	if (self->priv->restoring) {
		GHashTable* _tmp0_;
		GList* _tmp1_;
		GList* _tmp2_;
		_tmp0_ = self->priv->trash_items;
		_tmp1_ = g_hash_table_get_values (_tmp0_);
		_tmp2_ = _tmp1_;
		g_list_foreach (_tmp2_, ____lambda16__gfunc, self);
		(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	} else {
		GHashTable* _tmp3_;
		GList* _tmp4_;
		GList* _tmp5_;
		_tmp3_ = self->priv->trash_items;
		_tmp4_ = g_hash_table_get_values (_tmp3_);
		_tmp5_ = _tmp4_;
		g_list_foreach (_tmp5_, ____lambda17__gfunc, self);
		(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
	}
	_tmp6_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp6_, FALSE);
}

static void
___lambda15__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda15_ ((TrashAppletWidgetsTrashStoreWidget*) self);
}

static void
__lambda18_ (TrashAppletWidgetsTrashStoreWidget* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkRevealer* _tmp2_;
	_tmp0_ = self->priv->restore_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
	_tmp1_ = self->priv->delete_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
}

static void
___lambda18__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda18_ ((TrashAppletWidgetsTrashStoreWidget*) self);
}

static void
__lambda19_ (TrashAppletWidgetsTrashStoreWidget* self,
             GtkListBoxRow* row)
{
	TrashAppletWidgetsTrashItem* widget = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	g_return_if_fail (row != NULL);
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TRASH_APPLET_WIDGETS_TYPE_TRASH_ITEM, TrashAppletWidgetsTrashItem));
	widget = _tmp1_;
	trash_applet_widgets_trash_item_toggle_info_revealer (widget);
	_g_object_unref0 (widget);
}

static void
___lambda19__gtk_list_box_row_activated (GtkListBox* _sender,
                                         GtkListBoxRow* row,
                                         gpointer self)
{
	__lambda19_ ((TrashAppletWidgetsTrashStoreWidget*) self, row);
}

static void
trash_applet_widgets_trash_store_widget_connect_signals (TrashAppletWidgetsTrashStoreWidget* self)
{
	TrashAppletTrashStore* _tmp0_;
	TrashAppletTrashStore* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkListBox* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->trash_store;
	g_signal_connect_object (_tmp0_, "trash-added", (GCallback) _trash_applet_widgets_trash_store_widget_add_trash_item_trash_applet_trash_store_trash_added, self, 0);
	_tmp1_ = self->priv->trash_store;
	g_signal_connect_object (_tmp1_, "trash-removed", (GCallback) _trash_applet_widgets_trash_store_widget_remove_trash_item_trash_applet_trash_store_trash_removed, self, 0);
	_tmp2_ = self->priv->delete_button;
	g_signal_connect_object (_tmp2_, "clicked", (GCallback) ___lambda13__gtk_button_clicked, self, 0);
	_tmp3_ = self->priv->restore_button;
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) ___lambda14__gtk_button_clicked, self, 0);
	_tmp4_ = self->priv->confirm_button;
	g_signal_connect_object (_tmp4_, "clicked", (GCallback) ___lambda15__gtk_button_clicked, self, 0);
	_tmp5_ = self->priv->go_back_button;
	g_signal_connect_object (_tmp5_, "clicked", (GCallback) ___lambda18__gtk_button_clicked, self, 0);
	_tmp6_ = self->priv->file_box;
	g_signal_connect_object (_tmp6_, "row-activated", (GCallback) ___lambda19__gtk_list_box_row_activated, self, 0);
}

static void
trash_applet_widgets_trash_store_widget_set_buttons_sensitive (TrashAppletWidgetsTrashStoreWidget* self,
                                                               gboolean is_sensitive)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->restore_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, is_sensitive);
	_tmp1_ = self->priv->delete_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, is_sensitive);
}

static void
trash_applet_widgets_trash_store_widget_show_confirmation (TrashAppletWidgetsTrashStoreWidget* self,
                                                           gboolean restore)
{
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkRevealer* _tmp8_;
	g_return_if_fail (self != NULL);
	self->priv->restoring = restore;
	if (restore) {
		GtkLabel* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->revealer_text;
		_tmp1_ = g_strdup_printf ("<b>%s</b>", _ ("Really restore all items?"));
		_tmp2_ = _tmp1_;
		gtk_label_set_markup (_tmp0_, _tmp2_);
		_g_free0 (_tmp2_);
	} else {
		GtkLabel* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = self->priv->revealer_text;
		_tmp4_ = g_strdup_printf ("<b>%s</b>", _ ("Really delete all items?"));
		_tmp5_ = _tmp4_;
		gtk_label_set_markup (_tmp3_, _tmp5_);
		_g_free0 (_tmp5_);
	}
	_tmp6_ = self->priv->restore_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
	_tmp7_ = self->priv->delete_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
	_tmp8_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp8_, TRUE);
}

/**
         * sort_by_name will determine the order that two given rows should be in 
         * using pure alphabetical order.
         * 
         * @param row1 The first row to use for comparison
         * @param row2 The second row to use for comparison
         * @return < 0 if row1 should be before row2, 0 if they are equal and > 0 otherwise
         */
static gint
trash_applet_widgets_trash_store_widget_sort_by_name (TrashAppletWidgetsTrashStoreWidget* self,
                                                      GtkListBoxRow* row1,
                                                      GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
	trash_item_1 = _tmp1_;
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
	trash_item_2 = _tmp3_;
	_tmp4_ = trash_applet_widgets_trash_item_get_file_name (trash_item_1);
	_tmp5_ = _tmp4_;
	_tmp6_ = trash_applet_widgets_trash_item_get_file_name (trash_item_2);
	_tmp7_ = _tmp6_;
	result = g_utf8_collate (_tmp5_, _tmp7_);
	_g_object_unref0 (trash_item_2);
	_g_object_unref0 (trash_item_1);
	return result;
}

/**
         * sort_by_name_reverse will determine the order that two given rows should be in 
         * using reverse alphabetical order.
         * 
         * @param row1 The first row to use for comparison
         * @param row2 The second row to use for comparison
         * @return < 0 if row1 should be before row2, 0 if they are equal and > 0 otherwise
         */
static gint
trash_applet_widgets_trash_store_widget_sort_by_name_reverse (TrashAppletWidgetsTrashStoreWidget* self,
                                                              GtkListBoxRow* row1,
                                                              GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
	trash_item_1 = _tmp1_;
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
	trash_item_2 = _tmp3_;
	_tmp4_ = trash_applet_widgets_trash_item_get_file_name (trash_item_2);
	_tmp5_ = _tmp4_;
	_tmp6_ = trash_applet_widgets_trash_item_get_file_name (trash_item_1);
	_tmp7_ = _tmp6_;
	result = g_utf8_collate (_tmp5_, _tmp7_);
	_g_object_unref0 (trash_item_2);
	_g_object_unref0 (trash_item_1);
	return result;
}

/**
         * sort_by_type will determine the order that two given rows should be in.
         * 
         * Directories should be above files, and both types should be sorted alphabetically.
         * 
         * @param row1 The first row to use for comparison
         * @param row2 The second row to use for comparison
         * @return < 0 if row1 should be before row2, 0 if they are equal and > 0 otherwise
         */
static gint
trash_applet_widgets_trash_store_widget_sort_by_type (TrashAppletWidgetsTrashStoreWidget* self,
                                                      GtkListBoxRow* row1,
                                                      GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	gboolean _tmp4_ = FALSE;
	TrashAppletWidgetsTrashItem* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
	trash_item_1 = _tmp1_;
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
	trash_item_2 = _tmp3_;
	_tmp5_ = trash_item_1;
	_tmp6_ = trash_applet_widgets_trash_item_get_is_directory (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		TrashAppletWidgetsTrashItem* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp8_ = trash_item_2;
		_tmp9_ = trash_applet_widgets_trash_item_get_is_directory (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp4_ = _tmp10_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		TrashAppletWidgetsTrashItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		TrashAppletWidgetsTrashItem* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp11_ = trash_item_1;
		_tmp12_ = trash_applet_widgets_trash_item_get_file_name (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = trash_item_2;
		_tmp15_ = trash_applet_widgets_trash_item_get_file_name (_tmp14_);
		_tmp16_ = _tmp15_;
		result = g_utf8_collate (_tmp13_, _tmp16_);
		_g_object_unref0 (trash_item_2);
		_g_object_unref0 (trash_item_1);
		return result;
	} else {
		gboolean _tmp17_ = FALSE;
		TrashAppletWidgetsTrashItem* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
		_tmp18_ = trash_item_1;
		_tmp19_ = trash_applet_widgets_trash_item_get_is_directory (_tmp18_);
		_tmp20_ = _tmp19_;
		if (_tmp20_) {
			TrashAppletWidgetsTrashItem* _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
			_tmp21_ = trash_item_2;
			_tmp22_ = trash_applet_widgets_trash_item_get_is_directory (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp17_ = !_tmp23_;
		} else {
			_tmp17_ = FALSE;
		}
		if (_tmp17_) {
			result = -1;
			_g_object_unref0 (trash_item_2);
			_g_object_unref0 (trash_item_1);
			return result;
		} else {
			gboolean _tmp24_ = FALSE;
			TrashAppletWidgetsTrashItem* _tmp25_;
			gboolean _tmp26_;
			gboolean _tmp27_;
			_tmp25_ = trash_item_1;
			_tmp26_ = trash_applet_widgets_trash_item_get_is_directory (_tmp25_);
			_tmp27_ = _tmp26_;
			if (!_tmp27_) {
				TrashAppletWidgetsTrashItem* _tmp28_;
				gboolean _tmp29_;
				gboolean _tmp30_;
				_tmp28_ = trash_item_2;
				_tmp29_ = trash_applet_widgets_trash_item_get_is_directory (_tmp28_);
				_tmp30_ = _tmp29_;
				_tmp24_ = _tmp30_;
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				result = 1;
				_g_object_unref0 (trash_item_2);
				_g_object_unref0 (trash_item_1);
				return result;
			} else {
				TrashAppletWidgetsTrashItem* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				TrashAppletWidgetsTrashItem* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
				_tmp31_ = trash_item_1;
				_tmp32_ = trash_applet_widgets_trash_item_get_file_name (_tmp31_);
				_tmp33_ = _tmp32_;
				_tmp34_ = trash_item_2;
				_tmp35_ = trash_applet_widgets_trash_item_get_file_name (_tmp34_);
				_tmp36_ = _tmp35_;
				result = g_utf8_collate (_tmp33_, _tmp36_);
				_g_object_unref0 (trash_item_2);
				_g_object_unref0 (trash_item_1);
				return result;
			}
		}
	}
}

static gint
trash_applet_widgets_trash_store_widget_sort_by_newest (TrashAppletWidgetsTrashStoreWidget* self,
                                                        GtkListBoxRow* row1,
                                                        GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
	trash_item_1 = _tmp1_;
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
	trash_item_2 = _tmp3_;
	_tmp4_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_2);
	_tmp5_ = _tmp4_;
	_tmp6_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_1);
	_tmp7_ = _tmp6_;
	result = g_date_time_compare (_tmp5_, _tmp7_);
	_g_object_unref0 (trash_item_2);
	_g_object_unref0 (trash_item_1);
	return result;
}

static gint
trash_applet_widgets_trash_store_widget_sort_by_oldest (TrashAppletWidgetsTrashStoreWidget* self,
                                                        GtkListBoxRow* row1,
                                                        GtkListBoxRow* row2)
{
	TrashAppletWidgetsTrashItem* trash_item_1 = NULL;
	GtkWidget* _tmp0_;
	TrashAppletWidgetsTrashItem* _tmp1_;
	TrashAppletWidgetsTrashItem* trash_item_2 = NULL;
	GtkWidget* _tmp2_;
	TrashAppletWidgetsTrashItem* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
	_tmp1_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp0_) ? ((TrashAppletWidgetsTrashItem*) _tmp0_) : NULL);
	trash_item_1 = _tmp1_;
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
	_tmp3_ = _g_object_ref0 (TRASH_APPLET_WIDGETS_IS_TRASH_ITEM (_tmp2_) ? ((TrashAppletWidgetsTrashItem*) _tmp2_) : NULL);
	trash_item_2 = _tmp3_;
	_tmp4_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_1);
	_tmp5_ = _tmp4_;
	_tmp6_ = trash_applet_widgets_trash_item_get_deletion_time (trash_item_2);
	_tmp7_ = _tmp6_;
	result = g_date_time_compare (_tmp5_, _tmp7_);
	_g_object_unref0 (trash_item_2);
	_g_object_unref0 (trash_item_1);
	return result;
}

static void
trash_applet_widgets_trash_store_widget_class_init (TrashAppletWidgetsTrashStoreWidgetClass * klass,
                                                    gpointer klass_data)
{
	trash_applet_widgets_trash_store_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TrashAppletWidgetsTrashStoreWidget_private_offset);
	G_OBJECT_CLASS (klass)->finalize = trash_applet_widgets_trash_store_widget_finalize;
}

static void
trash_applet_widgets_trash_store_widget_instance_init (TrashAppletWidgetsTrashStoreWidget * self,
                                                       gpointer klass)
{
	self->priv = trash_applet_widgets_trash_store_widget_get_instance_private (self);
	self->priv->restoring = FALSE;
	self->priv->store_header = NULL;
	self->priv->drive_icon = NULL;
	self->priv->store_label = NULL;
	self->priv->restore_button = NULL;
	self->priv->delete_button = NULL;
	self->priv->revealer = NULL;
	self->priv->revealer_container = NULL;
	self->priv->revealer_text = NULL;
	self->priv->revealer_buttons = NULL;
	self->priv->go_back_button = NULL;
	self->priv->confirm_button = NULL;
	self->priv->file_box = NULL;
}

static void
trash_applet_widgets_trash_store_widget_finalize (GObject * obj)
{
	TrashAppletWidgetsTrashStoreWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRASH_APPLET_WIDGETS_TYPE_TRASH_STORE_WIDGET, TrashAppletWidgetsTrashStoreWidget);
	_trash_applet_trash_store_unref0 (self->priv->trash_store);
	_g_hash_table_unref0 (self->priv->trash_items);
	_g_object_unref0 (self->priv->store_header);
	_g_object_unref0 (self->priv->drive_icon);
	_g_object_unref0 (self->priv->store_label);
	_g_object_unref0 (self->priv->restore_button);
	_g_object_unref0 (self->priv->delete_button);
	_g_object_unref0 (self->priv->revealer);
	_g_object_unref0 (self->priv->revealer_container);
	_g_object_unref0 (self->priv->revealer_text);
	_g_object_unref0 (self->priv->revealer_buttons);
	_g_object_unref0 (self->priv->go_back_button);
	_g_object_unref0 (self->priv->confirm_button);
	_g_object_unref0 (self->priv->file_box);
	G_OBJECT_CLASS (trash_applet_widgets_trash_store_widget_parent_class)->finalize (obj);
}

GType
trash_applet_widgets_trash_store_widget_get_type (void)
{
	return trash_applet_widgets_trash_store_widget_type_id;
}

GType
trash_applet_widgets_trash_store_widget_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashAppletWidgetsTrashStoreWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_applet_widgets_trash_store_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashAppletWidgetsTrashStoreWidget), 0, (GInstanceInitFunc) trash_applet_widgets_trash_store_widget_instance_init, NULL };
	trash_applet_widgets_trash_store_widget_type_id = g_type_module_register_type (module, gtk_box_get_type (), "TrashAppletWidgetsTrashStoreWidget", &g_define_type_info, 0);
	TrashAppletWidgetsTrashStoreWidget_private_offset = sizeof (TrashAppletWidgetsTrashStoreWidgetPrivate);
	return trash_applet_widgets_trash_store_widget_type_id;
}

